//---------------------------------------------------------------
//------------------Safety-Stop for steppers---------------------
//---------------------------------------------------------------
void StepperStop() {

  //disable drivers
  setUmode(0);
  delay(20);
  setVmode(0);
  delay(20);
  setWmode(0);
  delay(20);
  setXmode(0);
  delay(20);
  setYmode(0);
  delay(20);
  setZmode(0);
  delay(500);
  digitalWrite(motorPowerEnable, LOW);
}



//---------------------------------------------------------------
//------------------Enable Stepper---------------------
//---------------------------------------------------------------
void StepperEnable() {

  digitalWrite(motorPowerEnable, HIGH);
  delay(500);
  //enable drivers with ramp-down
  if (stepperUactive == true) {
    setUmode(1);
    delay(200);
  }
  else {
    setUmode(0);
    delay(20);
  }



  if (stepperVactive == true) {
    setVmode(1);
    delay(200);
  }
  else {
    setVmode(0);
    delay(20);
  }


  if (stepperWactive == true) {
    setWmode(1);
    delay(200);
  }
  else {
    setWmode(0);
    delay(20);
  }


  if (stepperXactive == true) {
    setXmode(1);
    delay(200);
  }
  else {
    setXmode(0);
    delay(20);
  }

  if (stepperYactive == true) {
    setYmode(1);
    delay(200);
  }
  else {
    setYmode(0);
    delay(20);
  }

  if (stepperZactive == true) {
    setZmode(1);
    delay(200);
  }
  else {
    setZmode(0);
    delay(20);
  }


  AccelStepperU.setCurrentPosition(0);
  AccelStepperV.setCurrentPosition(0);
  AccelStepperW.setCurrentPosition(0);
  AccelStepperX.setCurrentPosition(0);
  AccelStepperY.setCurrentPosition(0);
  AccelStepperZ.setCurrentPosition(0);

}




//----------------------------------------------------
//------------------Set Stepper mode-----------------
//----------------------------------------------------

void setUmode(int Umode) {
  switch (Umode) {
    case 0:
      digitalWrite (Uenable, HIGH);
      break;

    case 1:
      digitalWrite (Uenable, LOW);
      setUresolution(UsetupRES);
      break;
  }
}

void setVmode(int Vmode) {
  switch (Vmode) {
    case 0:
      digitalWrite (Venable, HIGH);
      break;

    case 1:
      digitalWrite (Venable, LOW);
      setVresolution(VsetupRES);
      break;
  }
}

void setWmode(int Wmode) {
  switch (Wmode) {
    case 0:
      digitalWrite (Wenable, HIGH);
      break;

    case 1:
      digitalWrite (Wenable, LOW);
      setWresolution(WsetupRES);
      break;
  }
}

void setXmode(int Xmode) {
  switch (Xmode) {
    case 0:
      digitalWrite (Xenable, HIGH);

      break;

    case 1:
      digitalWrite (Xenable, LOW);
      setXresolution(XsetupRES);
      break;
  }
}

void setYmode(int Ymode) {
  switch (Ymode) {
    case 0:
      digitalWrite (Yenable, HIGH);

      break;

    case 1:
      digitalWrite (Yenable, LOW);
      setYresolution(YsetupRES);
      break;

  }
}
void setZmode(int Zmode) {
  switch (Zmode) {
    case 0:
      digitalWrite (Zenable, HIGH);

      break;

    case 1:
      digitalWrite (Zenable, LOW);

      setZresolution(ZsetupRES);
      break;
  }
}




//----------------------------------------------------
//------------------Set Stepper Resolution-----------------
//----------------------------------------------------




void setUresolution(int Uresolution) {

  driverU.begin();             // Initiate pins and registeries

  driverU.rms_current(rmscurrentU, currentholdU);   // Set stepper current to 600mA. The command is the same as command TMC2130.setCurrent(600, 0.11, 0.5);
  driverU.en_pwm_mode(1);      // Enable extremely quiet stepping
  driverU.pwm_autoscale(1);
  driverU.microsteps(Uresolution);
  driverU.intpol(1);

  Serial.print("rmscurrentU:");
  Serial.println(rmscurrentU);
  Serial.print("currentholdU:");
  Serial.println(currentholdU);

  AccelStepperU.setEnablePin(Uenable);
 // AccelStepperU.setPinsInverted(false, false, true);
  AccelStepperU.enableOutputs();
}

void setVresolution(int Vresolution) {

  driverV.begin();             // Initiate pins and registeries

  driverV.rms_current(rmscurrentV, currentholdV);   // Set stepper current to 600mA. The command is the same as command TMC2130.setCurrent(600, 0.11, 0.5);
  driverV.en_pwm_mode(1);      // Enable extremely quiet stepping
  driverV.pwm_autoscale(1);
  driverV.microsteps(Vresolution);
  driverV.intpol(1);

  Serial.print("rmscurrentV:");
  Serial.println(rmscurrentV);
  Serial.print("currentholdV:");
  Serial.println(currentholdV);

  AccelStepperV.setEnablePin(Venable);
 //AccelStepperV.setPinsInverted(false, false, true);
  AccelStepperV.enableOutputs();
}

void setWresolution(int Wresolution) {

  driverW.begin();             // Initiate pins and registeries

  driverW.rms_current(rmscurrentW, currentholdW);   // Set stepper current to 600mA. The command is the same as command TMC2130.setCurrent(600, 0.11, 0.5);
  driverW.en_pwm_mode(1);      // Enable extremely quiet stepping
  driverW.pwm_autoscale(1);
  driverW.microsteps(Wresolution);
  driverW.intpol(1);

  Serial.print("rmscurrentW:");
  Serial.println(rmscurrentW);
  Serial.print("currentholdW:");
  Serial.println(currentholdW);

  AccelStepperW.setEnablePin(Wenable);
  //AccelStepperW.setPinsInverted(false, false, true);
  AccelStepperW.enableOutputs();
}

void setXresolution(int Xresolution) {



  driverX.begin();             // Initiate pins and registeries

  driverX.rms_current(rmscurrentX, currentholdX);   // Set stepper current to 600mA. The command is the same as command TMC2130.setCurrent(600, 0.11, 0.5);
  driverX.en_pwm_mode(1);      // Enable extremely quiet stepping
  driverX.pwm_autoscale(1);
  driverX.microsteps(Xresolution);
  driverX.intpol(1);

  Serial.print("Xresolution:");
  Serial.println(Xresolution);
  Serial.print("rmscurrentX:");
  Serial.println(rmscurrentX);
  Serial.print("currentholdX:");
  Serial.println(currentholdX);

  AccelStepperX.setEnablePin(Xenable);
  //AccelStepperX.setPinsInverted(false, false, true);
  AccelStepperX.enableOutputs();

}

void setYresolution(int Yresolution) {



  driverY.begin();             // Initiate pins and registeries

  driverY.rms_current(rmscurrentY, currentholdY);   // Set stepper current to 600mA. The command is the same as command TMC2130.setCurrent(600, 0.11, 0.5);
  driverY.en_pwm_mode(1);      // Enable extremely quiet stepping
  driverY.pwm_autoscale(1);
  driverY.microsteps(Yresolution);
  driverY.intpol(1);

  Serial.print("rmscurrentY:");
  Serial.println(rmscurrentY);
  Serial.print("currentholdY:");
  Serial.println(currentholdY);
  AccelStepperY.setEnablePin(Yenable);
  //AccelStepperY.setPinsInverted(false, false, true);
  AccelStepperY.enableOutputs();

}

void setZresolution(int Zresolution) {

  driverZ.begin();             // Initiate pins and registeries

  driverZ.rms_current(rmscurrentZ, currentholdZ);   // Set stepper current to 600mA. The command is the same as command TMC2130.setCurrent(600, 0.11, 0.5);
  driverZ.en_pwm_mode(1);      // Enable extremely quiet stepping
  driverZ.pwm_autoscale(1);
  driverZ.microsteps(Zresolution);
  driverZ.intpol(1);

  Serial.print("rmscurrentZ:");
  Serial.println(rmscurrentZ);
  Serial.print("currentholdZ:");
  Serial.println(currentholdZ);

  AccelStepperZ.setEnablePin(Zenable);
  //AccelStepperZ.setPinsInverted(false, false, true);
  AccelStepperZ.enableOutputs();
}




//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveBackToStart() {

  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);

  AccelStepperU.run();
  AccelStepperV.run();
  AccelStepperW.run();
  AccelStepperX.run();
  AccelStepperY.run();
  AccelStepperZ.run();


  if (AccelStepperU.distanceToGo() == 0 && AccelStepperV.distanceToGo() == 0 && AccelStepperW.distanceToGo() == 0 && AccelStepperX.distanceToGo() == 0 && AccelStepperY.distanceToGo() == 0 && AccelStepperZ.distanceToGo() == 0) {
    movehome = false;
    myString = "0";
    StringSend = "#homeReached_" + myString + "$";
    Serial5.print(StringSend);
  }
}
//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveToKeyframe() {

  //AccelStepperX.setSpeed(-3000);
  Serial.print(AccelStepperX.speed());
  Serial.print(";");
  Serial.print(AccelStepperX.distanceToGo());
  Serial.print(";");
  Serial.print(AccelStepperX.targetPosition());
  Serial.print(";");
  Serial.println(AccelStepperX.currentPosition());
  Serial.println("----------------");

  prevMilliPS4y = millis();

  //delay(2000);

  while (AccelStepperU.currentPosition() != AccelStepperU.targetPosition() || AccelStepperV.currentPosition() != AccelStepperV.targetPosition() || AccelStepperW.currentPosition() != AccelStepperW.targetPosition() || AccelStepperX.currentPosition() != AccelStepperX.targetPosition() || AccelStepperY.currentPosition() != AccelStepperY.targetPosition() || AccelStepperZ.currentPosition() != AccelStepperZ.targetPosition()) {

    AccelStepperU.run();
    AccelStepperV.run();
    AccelStepperW.run();
    AccelStepperX.run();
    AccelStepperY.run();
    AccelStepperZ.run();

    /*
      if(millis()-prevMilliPS4y >5){
       Serial.print(speedY);
      Serial.print(";");
      Serial.print(AccelStepperY.speed());
      Serial.print(";");
      Serial.print(AccelStepperY.distanceToGo());
      Serial.print(";");
      Serial.print(AccelStepperY.targetPosition());
      Serial.print(";");
      Serial.println(AccelStepperY.currentPosition());
      prevMilliPS4y = millis();
    */
  }

  Serial.println("finish movekeyframe");

  moveKeyframe = false;

  myString = String(AccelStepperU.currentPosition());
  StringSend = "#curPosU_" + myString + "$";
  Serial5.print(StringSend);

  delay(40);
  myString = String(AccelStepperV.currentPosition());
  StringSend = "#curPosV_" + myString + "$";
  Serial5.print(StringSend);

  delay(40);
  myString = String(AccelStepperW.currentPosition());
  StringSend = "#curPosW_" + myString + "$";
  Serial5.print(StringSend);

  delay(40);
  myString = String(AccelStepperX.currentPosition());
  StringSend = "#curPosX_" + myString + "$";
  Serial5.print(StringSend);

  delay(40);
  myString = String(AccelStepperY.currentPosition());
  StringSend = "#curPosY_" + myString + "$";
  Serial5.print(StringSend);

  delay(40);
  myString = String(AccelStepperZ.currentPosition());
  StringSend = "#curPosZ_" + myString + "$";
  Serial5.print(StringSend);

  delay(40);
  myString = "0";
  StringSend = "#kfReached_" + myString + "$";
  Serial5.print(StringSend);
}
//----------------------------------------------------
//---------------Speed settings----------
//----------------------------------------------------


void setMaxSpeedSteppers() {
  AccelStepperU.setMaxSpeed(speedU);
  AccelStepperV.setMaxSpeed(speedV);
  AccelStepperW.setMaxSpeed(speedW);
  AccelStepperX.setMaxSpeed(speedX);
  AccelStepperY.setMaxSpeed(speedY);
  AccelStepperZ.setMaxSpeed(speedZ);

  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);
}





void backlashprocess() {
  AccelStepperX.setCurrentPosition(-1);
  AccelStepperX.setMaxSpeed(speedX);
  AccelStepperX.setAcceleration(speedX * 5);
  AccelStepperX.moveTo(-Xbacklash);
  long curposition = -1;

  while (curposition != 0) {


    AccelStepperX.run();
    curposition = AccelStepperX.currentPosition();
    if (curposition == -Xbacklash) {
      AccelStepperX.moveTo(0);
    }
  }


}

void idlecurrentwakeup() {

  //Set STEP & DIR low
  digitalWrite(Udir, LOW);
  digitalWrite(Vdir, LOW);
  digitalWrite(Wdir, LOW);
  digitalWrite(Xdir, LOW);
  digitalWrite(Ydir, LOW);
  digitalWrite(Zdir, LOW);
  digitalWrite(Ustep, LOW);
  digitalWrite(Vstep, LOW);
  digitalWrite(Wstep, LOW);
  digitalWrite(Xstep, LOW);
  digitalWrite(Ystep, LOW);
  digitalWrite(Zstep, LOW);

  //Set STEP High (=1 step)
  digitalWrite(Ustep, HIGH);
  digitalWrite(Vstep, HIGH);
  digitalWrite(Wstep, HIGH);
  digitalWrite(Xstep, HIGH);
  digitalWrite(Ystep, HIGH);
  digitalWrite(Zstep, HIGH);
  delay(1);
  //Set STEP Low
  digitalWrite(Ustep, LOW);
  digitalWrite(Vstep, LOW);
  digitalWrite(Wstep, LOW);
  digitalWrite(Xstep, LOW);
  digitalWrite(Ystep, LOW);
  digitalWrite(Zstep, LOW);
  //Set DIR HIGH (change direction)
  digitalWrite(Udir, HIGH);
  digitalWrite(Vdir, HIGH);
  digitalWrite(Wdir, HIGH);
  digitalWrite(Xdir, HIGH);
  digitalWrite(Ydir, HIGH);
  digitalWrite(Zdir, HIGH);
  delay(1);
  //Set STEP High (=1 step)
  digitalWrite(Ustep, HIGH);
  digitalWrite(Vstep, HIGH);
  digitalWrite(Wstep, HIGH);
  digitalWrite(Xstep, HIGH);
  digitalWrite(Ystep, HIGH);
  digitalWrite(Zstep, HIGH);
  delay(1);
  //Set STEP & DIR Low
  digitalWrite(Ustep, LOW);
  digitalWrite(Vstep, LOW);
  digitalWrite(Wstep, LOW);
  digitalWrite(Xstep, LOW);
  digitalWrite(Ystep, LOW);
  digitalWrite(Zstep, LOW);
  digitalWrite(Udir, LOW);
  digitalWrite(Vdir, LOW);
  digitalWrite(Wdir, LOW);
  digitalWrite(Xdir, LOW);
  digitalWrite(Ydir, LOW);
  digitalWrite(Zdir, LOW);

  delay(50);
}
