
void setVideoData() {
  PS4disconnect();
  Serial.println("PS4disconnect7");

  // Serial.println("-------------------");
  /*
    AccelStepperU.setCurrentPosition(0);
    AccelStepperV.setCurrentPosition(0);
    AccelStepperW.setCurrentPosition(0);
    AccelStepperX.setCurrentPosition(0);
    AccelStepperY.setCurrentPosition(0);
    AccelStepperZ.setCurrentPosition(0);
  */


  tempCurveU.setPoints(n_u20, u20, keyframeAmountU);
  tempCurveU.setDegree(Catmull);

  tempCurveV.setPoints(n_v20, v20, keyframeAmountV);
  tempCurveV.setDegree(Catmull);

  tempCurveW.setPoints(n_w20, w20, keyframeAmountW);
  tempCurveW.setDegree(Catmull);

  tempCurveX.setPoints(n_x20, x20, keyframeAmountX);
  tempCurveX.setDegree(Catmull);

  tempCurveY.setPoints(n_y20, y20, keyframeAmountY);
  tempCurveY.setDegree(Catmull);

  tempCurveZ.setPoints(n_z20, z20, keyframeAmountZ);
  tempCurveZ.setDegree(Catmull);


  //-----------------fill Spline arrays with points---------------------------
  for (int i = 0; i < (splinepointamount + 2); i++) {

    float tempU = tempCurveU.value(i);
    tempGerundetU = long(tempU + 0.5);
    myArrayU[i] = tempGerundetU;
    //  Serial.println(tempGerundetU);

    float tempV = tempCurveV.value(i);
    tempGerundetV = long(tempV + 0.5);
    myArrayV[i] = tempGerundetV;

    float tempW = tempCurveW.value(i);
    tempGerundetW = long(tempW + 0.5);
    myArrayW[i] = tempGerundetW;

    float tempX = tempCurveX.value(i);
    tempGerundetX = long(tempX + 0.5);
    myArrayX[i] = tempGerundetX;

    float tempY = tempCurveY.value(i);
    tempGerundetY = long(tempY + 0.5);
    myArrayY[i] = tempGerundetY;

    //  Serial.println(myArrayY[i]);

    float tempZ = tempCurveZ.value(i);
    tempGerundetZ = long(tempZ + 0.5);
    myArrayZ[i] = tempGerundetZ;


  }
  videoMaxMoveSpeedU = 0;
  videoMaxMoveSpeedV = 0;
  videoMaxMoveSpeedW = 0;
  videoMaxMoveSpeedX = 0;
  videoMaxMoveSpeedY = 0;
  videoMaxMoveSpeedZ = 0;


  //----------------Calculate max. Speed--------------------------
  for (int i = 1; i <= (splinepointamount * 0.1); i++) {
    float timeduration = (VideoDuration) / (splinepointamount * 0.1);
    //Serial.println(i);
    //----------------------U-axis----------------------------
    float currentPosTempU = tempCurveU.value(i * 10);
    float currentPosUgerund = long(currentPosTempU + 0.5);
    float prevPosTempU = tempCurveU.value(i * 10 - 10);
    float prevPosTempUgerund = long(prevPosTempU + 0.5);

    int splineSpeedU = (currentPosUgerund - prevPosTempUgerund) / timeduration;
    if (abs(splineSpeedU) > videoMaxMoveSpeedU) {
      videoMaxMoveSpeedU = abs(splineSpeedU);
    }

    //----------------------V-axis----------------------------
    float currentPosTempV = tempCurveV.value(i * 10);
    float currentPosVgerund = long(currentPosTempV + 0.5);
    float prevPosTempV = tempCurveV.value(i * 10 - 10);
    float prevPosTempVgerund = long(prevPosTempV + 0.5);

    int splineSpeedV = (currentPosVgerund - prevPosTempVgerund) / timeduration;
    if (abs(splineSpeedV) > videoMaxMoveSpeedV) {
      videoMaxMoveSpeedV = abs(splineSpeedV);
    }
    //----------------------W-axis----------------------------
    float currentPosTempW = tempCurveW.value(i * 10);
    float currentPosWgerund = long(currentPosTempW + 0.5);
    float prevPosTempW = tempCurveW.value(i * 10 - 10);
    float prevPosTempWgerund = long(prevPosTempW + 0.5);

    int splineSpeedW = (currentPosWgerund - prevPosTempWgerund) / timeduration;
    if (abs(splineSpeedW) > videoMaxMoveSpeedW) {
      videoMaxMoveSpeedW = abs(splineSpeedW);
    }
    //----------------------X-axis----------------------------
    float currentPosTempX = tempCurveX.value(i * 10);
    float currentPosXgerund = long(currentPosTempX + 0.5);
    float prevPosTempX = tempCurveX.value(i * 10 - 10);
    float prevPosTempXgerund = long(prevPosTempX + 0.5);

    int splineSpeedX = (currentPosXgerund - prevPosTempXgerund) / timeduration;
    if (abs(splineSpeedX) > videoMaxMoveSpeedX) {
      videoMaxMoveSpeedX = abs(splineSpeedX);
    }

    /*
       Serial.print(timeduration * i);
       Serial.print(";");
       Serial.print(myArrayX[i * 10]);
       Serial.print(";");
       Serial.println(myArrayX[i * 10 - 10]);
    */


    //----------------------Y-axis----------------------------
    float currentPosTempY = tempCurveY.value(i * 10);
    float currentPosYgerund = long(currentPosTempY + 0.5);
    float prevPosTempY = tempCurveY.value(i * 10 - 10);
    float prevPosTempYgerund = long(prevPosTempY + 0.5);

    int splineSpeedY = (currentPosYgerund - prevPosTempYgerund) / timeduration;
    if (abs(splineSpeedY) > videoMaxMoveSpeedY) {
      videoMaxMoveSpeedY = abs(splineSpeedY);
    }

    /*
       Serial.print(timeduration * i);
       Serial.print(";");
       Serial.print(myArrayY[i * 10]);
       Serial.print(";");
       Serial.println(myArrayY[i * 10 - 10]);
    */

    //----------------------Z-axis----------------------------
    float currentPosTempZ = tempCurveZ.value(i * 10);
    float currentPosZgerund = long(currentPosTempZ + 0.5);
    float prevPosTempZ = tempCurveZ.value(i * 10 - 10);
    float prevPosTempZgerund = long(prevPosTempZ + 0.5);

    int splineSpeedZ = (currentPosZgerund - prevPosTempZgerund) / timeduration;
    if (abs(splineSpeedZ) > videoMaxMoveSpeedZ) {
      videoMaxMoveSpeedZ = abs(splineSpeedZ);
    }
  }
  /*
      //----------------Calculate calculation time (~22 seconds)------------------------
      currentMillisVidArray = millis();
      deltaVidArray = currentMillisVidArray - previousMillisVidArray;

      Serial.println(deltaVidArray);

  */


}

void transmitValues() {

  myString = String(videoMaxMoveSpeedU);
  StringSend = "#vidMaxSu_" + myString + "$";
  Serial5.print(StringSend);
  delay(40);

  myString = String(videoMaxMoveSpeedV);
  StringSend = "#vidMaxSv_" + myString + "$";
  Serial5.print(StringSend);
  delay(40);

  myString = String(videoMaxMoveSpeedW);
  StringSend = "#vidMaxSw_" + myString + "$";
  Serial5.print(StringSend);
  delay(40);

  myString = String(videoMaxMoveSpeedX);
  StringSend = "#vidMaxSx_" + myString + "$";
  Serial5.print(StringSend);
  //Serial.print(StringSend);
  delay(40);

  myString = String(videoMaxMoveSpeedY);
  StringSend = "#vidMaxSy_" + myString + "$";
  Serial5.print(StringSend);
  delay(40);

  myString = String(videoMaxMoveSpeedZ);
  StringSend = "#vidMaxSz_" + myString + "$";
  Serial5.print(StringSend);
  Serial.println(StringSend);
  delay(40);

  float videoPointUpdateTimeD = (((float)VideoDuration * 1000000) / splinepointamount);
  videoPointUpdateTime = long(videoPointUpdateTimeD + 0.5);

  Serial.print("VideoDuration:");
  Serial.println(VideoDuration, 4);
  Serial.print("videoPointUpdateTimeD:");
  Serial.println(videoPointUpdateTimeD, 4);
  Serial.print("videoPointUpdateTime:");
  Serial.println(videoPointUpdateTime);



  millisforcalc = millis();
  durationofcalc = millisforcalc - millisforcalcPREV;

}


void Splinevideoloop() {
  float lastSpeed;

  while (startMovie == true) {
    currentMillisVidArray = micros();
    deltaVidArray = currentMillisVidArray - previousMillisVidArray;

    if (deltaVidArray > (videoPointUpdateTime - 24) && posii <= splinepointamount) {

      if (posii <= splinepointamount) {
        //---------------Uaxis-----------------
        long currentPosU = myArrayU[posii];
        long nextPosU = myArrayU[posii + 1];
        long diffU = nextPosU - currentPosU;
        SpeedUnew = (diffU * 1000000 / videoPointUpdateTime);
        //---------------Vaxis-----------------
        long currentPosV = myArrayV[posii];
        long nextPosV = myArrayV[posii + 1];
        long diffV = nextPosV - currentPosV;
        SpeedVnew = (diffV * 1000000 / videoPointUpdateTime);
        //---------------Waxis-----------------
        long currentPosW = myArrayW[posii];
        long nextPosW = myArrayW[posii + 1];
        long diffW = nextPosW - currentPosW;
        SpeedWnew = (diffW * 1000000 / videoPointUpdateTime);

        //---------------Xaxis-----------------
        long currentPosX = myArrayX[posii];
        long nextPosX = myArrayX[posii + 1];
        long diffX = nextPosX - currentPosX;
        SpeedXnew = (diffX * 1000000 / videoPointUpdateTime);

        if (SpeedXnew != 0) {
          lastSpeed = SpeedXnew;
        }
        //---------------Yaxis-----------------
        long currentPosY = myArrayY[posii];
        long nextPosY = myArrayY[posii + 1];
        long diffY = nextPosY - currentPosY;
        SpeedYnew = (diffY * 1000000 / videoPointUpdateTime);


        Serial.print(micros());
        Serial.print(";");
        Serial.print(posii);
        Serial.print(";");
        Serial.print(currentPosY);
        Serial.print(";");
        Serial.print(nextPosY);
        Serial.print(";");
        Serial.print(AccelStepperY.currentPosition());
        Serial.print(";");
        Serial.println(SpeedYnew);



        //---------------Zaxis-----------------
        long currentPosZ = myArrayZ[posii];
        long nextPosZ = myArrayZ[posii + 1];
        long diffZ = nextPosZ - currentPosZ;
        SpeedZnew = (diffZ * 1000000 / videoPointUpdateTime);

        AccelStepperX.moveTo(myArrayX[posii + 1]);
        AccelStepperY.moveTo(myArrayY[posii + 1]);
        AccelStepperZ.moveTo(myArrayZ[posii + 1]);
        AccelStepperU.moveTo(myArrayU[posii + 1]);
        AccelStepperV.moveTo(myArrayV[posii + 1]);
        AccelStepperW.moveTo(myArrayW[posii + 1]);

        AccelStepperX.setSpeed(SpeedXnew);
        AccelStepperY.setSpeed(SpeedYnew);
        AccelStepperZ.setSpeed(SpeedZnew);
        AccelStepperU.setSpeed(SpeedUnew);
        AccelStepperV.setSpeed(SpeedVnew);
        AccelStepperW.setSpeed(SpeedWnew);

      }




      if (posii == splinepointamount) {
        startMovie = false;
      }
      else {
        posii++;
      }
      previousMillisVidArray = micros();



    }


    AccelStepperU.runSpeedToPosition();
    AccelStepperV.runSpeedToPosition();
    AccelStepperW.runSpeedToPosition();
    AccelStepperX.runSpeedToPosition();
    AccelStepperY.runSpeedToPosition();
    AccelStepperZ.runSpeedToPosition();

  }

  if (posii == splinepointamount ) {

    AccelStepperU.setMaxSpeed(speedU);
    AccelStepperV.setMaxSpeed(speedV);
    AccelStepperW.setMaxSpeed(speedW);
    AccelStepperX.setMaxSpeed(speedX);
    AccelStepperY.setMaxSpeed(speedY);
    AccelStepperZ.setMaxSpeed(speedZ);

    AccelStepperU.setAcceleration(speedU / 2);
    AccelStepperV.setAcceleration(speedV / 2);
    AccelStepperW.setAcceleration(speedW / 2);
    AccelStepperX.setAcceleration(speedX / 2);
    AccelStepperY.setAcceleration(speedY / 2);
    AccelStepperZ.setAcceleration(speedZ / 2);


    AccelStepperU.setCurrentPosition(AccelStepperU.currentPosition());
    AccelStepperV.setCurrentPosition(AccelStepperV.currentPosition());
    AccelStepperW.setCurrentPosition(AccelStepperW.currentPosition());
    AccelStepperX.setCurrentPosition(AccelStepperX.currentPosition());
    AccelStepperY.setCurrentPosition(AccelStepperY.currentPosition());
    AccelStepperZ.setCurrentPosition(AccelStepperZ.currentPosition());

    Serial.println("moveFINISHED");
    Serial.print("Ycurrent:");
    Serial.println(AccelStepperY.currentPosition());
    Serial.print("distanceToGo2:");
    Serial.println(AccelStepperY.distanceToGo());
  }

}


//-----------runMovie Reverse--------------
void SplinevideoloopReverse() {

  while (startMovie == true) {
    currentMillisVidArray = micros();
    deltaVidArray = currentMillisVidArray - previousMillisVidArray;

    if (deltaVidArray > (videoPointUpdateTime - 24) && posii >= 0) {

      if (posii >= 0) {
        //---------------Uaxis-----------------
        long currentPosU = myArrayU[posii];
        long nextPosU = myArrayU[posii - 1];
        long diffU = nextPosU - currentPosU;
        SpeedUnew = (diffU * 1000000 / videoPointUpdateTime);
        //---------------Vaxis-----------------
        long currentPosV = myArrayV[posii];
        long nextPosV = myArrayV[posii - 1];
        long diffV = nextPosV - currentPosV;
        SpeedVnew = (diffV * 1000000 / videoPointUpdateTime);
        //---------------Waxis-----------------
        long currentPosW = myArrayW[posii];
        long nextPosW = myArrayW[posii - 1];
        long diffW = nextPosW - currentPosW;
        SpeedWnew = (diffW * 1000000 / videoPointUpdateTime);

        //---------------Xaxis-----------------
        long currentPosX = myArrayX[posii];
        long nextPosX = myArrayX[posii - 1];
        long diffX = nextPosX - currentPosX;
        SpeedXnew = (diffX * 1000000 / videoPointUpdateTime);

        //---------------Yaxis-----------------
        long currentPosY = myArrayY[posii];
        long nextPosY = myArrayY[posii - 1];
        long diffY = nextPosY - currentPosY;
        SpeedYnew = (diffY * 1000000 / videoPointUpdateTime);


        Serial.print(micros());
        Serial.print(";");
        Serial.print(posii);
        Serial.print(";");
        Serial.print(currentPosY);
        Serial.print(";");
        Serial.print(nextPosY);
        Serial.print(";");
        Serial.print(AccelStepperY.currentPosition());
        Serial.print(";");
        Serial.println(SpeedYnew);


        //---------------Zaxis-----------------
        long currentPosZ = myArrayZ[posii];
        long nextPosZ = myArrayZ[posii - 1];
        long diffZ = nextPosZ - currentPosZ;
        SpeedZnew = (diffZ * 1000000 / videoPointUpdateTime);



      }

      AccelStepperX.moveTo(myArrayX[posii-1]);
      AccelStepperY.moveTo(myArrayY[posii-1]);
      AccelStepperZ.moveTo(myArrayZ[posii-1]);
      AccelStepperU.moveTo(myArrayU[posii-1]);
      AccelStepperV.moveTo(myArrayV[posii-1]);
      AccelStepperW.moveTo(myArrayW[posii-1]);

      AccelStepperX.setSpeed(SpeedXnew);
      AccelStepperY.setSpeed(SpeedYnew);
      AccelStepperZ.setSpeed(SpeedZnew);
      AccelStepperU.setSpeed(SpeedUnew);
      AccelStepperV.setSpeed(SpeedVnew);
      AccelStepperW.setSpeed(SpeedWnew);


      if (posii == 0) {
        startMovie = false;
      }
      else {
        posii--;
      }
      previousMillisVidArray = micros();

    }


    AccelStepperU.runSpeedToPosition();
    AccelStepperV.runSpeedToPosition();
    AccelStepperW.runSpeedToPosition();
    AccelStepperX.runSpeedToPosition();
    AccelStepperY.runSpeedToPosition();
    AccelStepperZ.runSpeedToPosition();

  }

  if (posii == 0) {

    AccelStepperU.setMaxSpeed(speedU);
    AccelStepperV.setMaxSpeed(speedV);
    AccelStepperW.setMaxSpeed(speedW);
    AccelStepperX.setMaxSpeed(speedX);
    AccelStepperY.setMaxSpeed(speedY);
    AccelStepperZ.setMaxSpeed(speedZ);

    AccelStepperU.setAcceleration(speedU / 2);
    AccelStepperV.setAcceleration(speedV / 2);
    AccelStepperW.setAcceleration(speedW / 2);
    AccelStepperX.setAcceleration(speedX / 2);
    AccelStepperY.setAcceleration(speedY / 2);
    AccelStepperZ.setAcceleration(speedZ / 2);


    AccelStepperU.setCurrentPosition(AccelStepperU.currentPosition());
    AccelStepperV.setCurrentPosition(AccelStepperV.currentPosition());
    AccelStepperW.setCurrentPosition(AccelStepperW.currentPosition());
    AccelStepperX.setCurrentPosition(AccelStepperX.currentPosition());
    AccelStepperY.setCurrentPosition(AccelStepperY.currentPosition());
    AccelStepperZ.setCurrentPosition(AccelStepperZ.currentPosition());

    Serial.println("moveFINISHED");
    Serial.print("Ycurrent:");
    Serial.println(AccelStepperY.currentPosition());
    Serial.print("distanceToGo2:");
    Serial.println(AccelStepperY.distanceToGo());
  }

}
