//-----------------------------------------------
//---------------Panorama horizontal-----------
//-----------------------------------------------

void PanoLoop() {

  unsigned long currentMillis = millis();


  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);


  AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();

  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();


  if (panoCurrentPic < panoTotalPicAmount && pausePano == false) {
    if (currentMillis  - previousMillis > SMSdauer )
    {
      SMSstep++;  // nächster Schritt


      switch (SMSstep)
      {
        case 1: //DSLR auslösen

          digitalWrite(dslrFocus, HIGH);
          digitalWrite(dslrTrigger, HIGH);
          SMSdauer = 200; // sec warten
          break;

        case 2: //Belichten und Warten
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          panoCurrentPic++;

          myString = String(panoCurrentPic);
          StringSend = "#panoCurrentPic_" + myString + "$";
          Serial5.print(StringSend);

          SMSdauer = TLmaxexpo;
          break;

        case 3: // Move



          if (((int)currentRow % 2) == 1) {
            if (currentColumn == panoColumns) {
              currentColumn = panoColumns;
              currentRow = currentRow + 1;
              //   Serial.println("---1");
            }
            else {
              currentColumn = currentColumn + 1;

              // Serial.println(currentColumn);

            }
          }

          else {
            if (currentColumn == 1) {
              currentColumn = 1;
              currentRow = currentRow + 1;

              // Serial.println("---3");
            }
            else {
              currentColumn = currentColumn - 1;
              // Serial.println("---4");
            }
          }



          currentColumnFLOAT =  ((float)currentColumn - 1) * PanoHorizontalMoveSteps;
          tempGerundetX = long(currentColumnFLOAT);

          currentRowFLOAT =  ((float)currentRow - 1) * PanoVerticalMoveSteps;
          tempGerundetY = long(currentRowFLOAT);

          myString = String(currentColumn);
          StringSend = "#currentColumn_" + myString + "$";
          Serial5.print(StringSend);

          delay(50);
          myString = String(currentRow);
          StringSend = "#currentRow_" + myString + "$";
          Serial5.print(StringSend);

          SMSdauer = 500;
          break;

        case 4: // Delay

          SMSdauer = TLdelay + 500;
          if (TLdelay > 1000) {
            SMSdauer = 1500;
          }



          break;

        default:
          // Serial.println(AccelStepperY.currentPosition());
          SMSstep = 0;
          SMSdauer = 1;     // Schrittfolge wieder von vorn
      }

      if (pausePano == false) {
        // Serial.println("444");
        previousMillis = currentMillis; // "Delay" neu starten
      }

    }  //  if (currentMillis  - previousMillis > Dauer )
  }

  else {
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);

    if (panoCurrentPic == panoTotalPicAmount) {
      tempGerundetX = 0;
      tempGerundetY = 0;
      SMSstep = 0;
      previousMillis = 0;
      Serial.println("Pano finished");
      startPano = false;
    }

  }

}

//-----------------------------------------------
//---------------Panorama vertical-----------
//-----------------------------------------------

void PanoLoopVertical() {


  unsigned long currentMillis = millis();


  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);


  AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();

  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();

  if (panoCurrentPic < panoTotalPicAmount && pausePano == false) {
    //Serial.println("111");
    if (currentMillis  - previousMillis > SMSdauer )
    {
      SMSstep++;  // nächster Schritt
      //Serial.println("222");
      switch (SMSstep)
      {
        case 1: //DSLR auslösen

          digitalWrite(dslrFocus, HIGH);
          digitalWrite(dslrTrigger, HIGH);
          SMSdauer = 200; // sec warten
          break;

        case 2: //Belichten und Warten
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          panoCurrentPic++;

          myString = String(panoCurrentPic);
          StringSend = "#panoCurrentPic_" + myString + "$";
          Serial5.print(StringSend);
          SMSdauer = TLmaxexpo;

          break;

        case 3: //DSLR auslösen
          SMSdauer = 0;
          if (TLmaxexpo2 > 0) {
            digitalWrite(dslrFocus, HIGH);
            digitalWrite(dslrTrigger, HIGH);
            SMSdauer = 200; // sec warten
          }

          break;

        case 4: //Belichten und Warten
          SMSdauer = 0;

          if (TLmaxexpo2 > 0) {
            digitalWrite(dslrTrigger, LOW);
            digitalWrite(dslrFocus, LOW);
            panoCurrentPic++;

            myString = String(panoCurrentPic);
            StringSend = "#panoCurrentPic_" + myString + "$";
            Serial5.print(StringSend);
            SMSdauer = TLmaxexpo2+TLmaxdelay2;
          }
          break;

        case 5: //DSLR auslösen

          SMSdauer = 0;
          if (TLmaxexpo3 > 0) {
            digitalWrite(dslrFocus, HIGH);
            digitalWrite(dslrTrigger, HIGH);
            SMSdauer = 200; // sec warten
          }
          break;

        case 6: //Belichten und Warten
         SMSdauer = 0;

          if (TLmaxexpo3 > 0) {
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          panoCurrentPic++;

          myString = String(panoCurrentPic);
          StringSend = "#panoCurrentPic_" + myString + "$";
          Serial5.print(StringSend);
          SMSdauer = TLmaxexpo3+TLmaxdelay3;
          }
          break;

        case 7: // Move

          if (((int)currentColumn % 2) == 1) {
            if (currentRow == panoRows) {
              currentRow = panoRows;
              currentColumn = currentColumn + 1;
              //   Serial.println("---1");
            }
            else {
              currentRow = currentRow + 1;

              // Serial.println(currentColumn);

            }
          }

          else {
            if (currentRow == 1) {
              currentRow = 1;
              currentColumn = currentColumn + 1;

              // Serial.println("---3");
            }
            else {
              currentRow = currentRow - 1;
              // Serial.println("---4");
            }
          }

          myString = String(currentColumn);
          StringSend = "#currentColumn_" + myString + "$";
          Serial5.print(StringSend);

          delay(50);
          myString = String(currentRow);
          StringSend = "#currentRow_" + myString + "$";
          Serial5.print(StringSend);

          currentColumnFLOAT =  ((float)currentColumn - 1) * PanoHorizontalMoveSteps;
          tempGerundetX = long(currentColumnFLOAT);

          currentRowFLOAT =  ((float)currentRow - 1) * PanoVerticalMoveSteps;
          tempGerundetY = long(currentRowFLOAT);





          SMSdauer = 500;
          break;

        case 8: // Delay
          SMSdauer = TLdelay + 500;
          Serial.print("TLdel:");
          Serial.println(SMSdauer);
          

          break;

        default:
          // Serial.println(AccelStepperY.currentPosition());
          SMSstep = 0;
          SMSdauer = 1;     // Schrittfolge wieder von vorn
      }

      if (pausePano == false) {
        //  Serial.println("444");
        previousMillis = currentMillis; // "Delay" neu starten
      }


    }  //  if (currentMillis  - previousMillis > Dauer )
  }
  else {
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);

    if (panoCurrentPic == panoTotalPicAmount) {
      SMSstep = 0;
      previousMillis = 0;
      tempGerundetX = 0;
      tempGerundetY = 0;
      startPanoVertical = false;
      Serial.println("Pano finished");
    }


  }

}
