
#include <AccelStepper.h>
#include <spline.h>
#include "SPI.h"
#include <PS4BT.h>
#include <usbhub.h>
#include <TMCStepper.h>

#ifdef dobogusinclude
#include <spi4teensy3.h>
#include <SPI.h>
#endif

//-------------Versionsnummer----------------
String versionNo = "30100";

//------USB-host-shield(PS4-controller)--------
USB Usb;
BTD Btd(&Usb);
//PS4BT PS4(&Btd, PAIR);
PS4BT PS4(&Btd);
bool printAngle, printTouch;
uint8_t oldL2Value, oldR2Value;

boolean moveUactive = false;
boolean moveVactive = false;
boolean moveWactive = false;
boolean moveXactive = false;
boolean moveYactive = false;
boolean moveZactive = false;

boolean softJoystickUactive = false;
boolean softJoystickVactive = false;
boolean softJoystickWactive = false;
boolean softJoystickXactive = false;
boolean softJoystickYactive = false;
boolean softJoystickZactive = false;

boolean constantspeedUactive = false;
boolean constantspeedVactive = false;
boolean constantspeedWactive = false;
boolean constantspeedXactive = false;
boolean constantspeedYactive = false;
boolean constantspeedZactive = false;



bool switchreached = false;
bool switchhit = false;

unsigned long prevMilliPS4u = 0;
unsigned long prevMilliPS4v = 0;
unsigned long prevMilliPS4w = 0;
unsigned long prevMilliPS4x = 0;
unsigned long prevMilliPS4y = 0;
unsigned long prevMilliPS4z = 0;

unsigned long prevmillmovv = 0;

boolean ps4transmitdelayU = false;
boolean ps4transmitdelayV = false;
boolean ps4transmitdelayW = false;
boolean ps4transmitdelayX = false;
boolean ps4transmitdelayY = false;
boolean ps4transmitdelayZ = false;
unsigned long transmitMillisU = 0;
unsigned long transmitMillisV = 0;
unsigned long transmitMillisW = 0;
unsigned long transmitMillisX = 0;
unsigned long transmitMillisY = 0;
unsigned long transmitMillisZ = 0;

String tpart1_joyLeftXaxis;
String tpart2_joyLeftYaxis;
String tpart3_joyRightXaxis;
String tpart4_joyRightYaxis;
String tpart5_joyLeftXposi;
String tpart6_joyLeftYposi;
String tpart7_joyRightXposi;
String tpart8_joyRightYposi;

byte joyLeftXaxis;
byte joyLeftYaxis;
byte joyRightXaxis;
byte joyRightYaxis;

float intervalFloat = 0;
float MaxExpoFloat = 0;


byte currentLEDcolor = 0;
byte ps4LEDmode = 0; // 0 = standard - 1=OFF - 2=White
byte joystickLeftMode = 1; // 0= both - 1=Xonly - 2=Vonly
byte joystickRightMode = 1; // 0= both - 1=Xonly - 2=Wonly

int tlPause = 0;
int panoPause = 0;

//-------------TMC2130 registers-------------
#define WRITE          0x80 //write flag
#define REG_GCONF      0x00
#define REG_GSTAT      0x01
#define REG_IHOLD_IRUN 0x10
#define REG_TPOWERDOWN 0x11
#define REG_CHOPCONF   0x6C
#define REG_COOLCONF   0x6D
#define REG_DCCTRL     0x6E
#define REG_DRVSTATUS  0x6F

char charvalue = '0';

//--------------IHOLDIRUN--------------
// 31 = 100%
char IHOLDIRUN[5];
uint32_t IHOLDIRUNvalue;

byte IHOLDu = 5;
byte IHOLDv = 5;
byte IHOLDw = 5;
byte IHOLDx = 5;
byte IHOLDy = 5;
byte IHOLDz = 5;

byte IRUNu = 10;
byte IRUNv = 10;
byte IRUNw = 10;
byte IRUNx = 31;
byte IRUNy = 31;
byte IRUNz = 31;

int driverRMScurrent = 600;
int rmscurrentU = 600;
int rmscurrentV = 600;
int rmscurrentW = 600;
int rmscurrentX = 600;
int rmscurrentY = 600;
int rmscurrentZ = 600;

float currentholdU = 0.4;
float currentholdV = 0.4;
float currentholdW = 0.4;
float currentholdX = 0.4;
float currentholdY = 0.4;
float currentholdZ = 0.4;

byte IHOLDDELAYall = 3;

//------------------Bluetooth----------------

String StringSend;
String myString;

String commandStr;

//-------------SPI-settings-----------------------
SPISettings settingsA(4000000, MSBFIRST, SPI_MODE3);

//-------------Defintion for AccelStepper-----------------
//----------------------Teensy 3.6------------------------
unsigned long reachedtime = 0;

float SpeedUnew = 0;
float SpeedVnew = 0;
float SpeedWnew = 0;
float SpeedXnew = 0;
float SpeedYnew = 0;
float SpeedZnew = 0;




const int Uenable = 30;
const int Venable = 36;
const int Wenable = 38;
const int Xenable = 5;
const int Yenable = 8;
const int Zenable = 25;

const int Ucs = 29;
const int Vcs = 35;
const int Wcs = 37;
const int Xcs = 4;
const int Ycs = 9;
const int Zcs = 26;

int Ustep = 28; //Pin 28
int Udir = 27;//Pin 27
int Vstep = 32;//Pin 32
int Vdir = 31;//Pin 31
int Wstep = 39; //Pin 39  - AUX: 48
int Wdir = 14;//Pin 14  - AUX: 47
int Xstep = 3;//Pin 3
int Xdir = 2;//Pin 2
int Ystep = 7;//Pin 7
int Ydir = 6;//Pin 6
int Zstep = 24;///Pin 24
int Zdir = 10;//Pin 10

AccelStepper AccelStepperU(1, Ustep, Udir);
AccelStepper AccelStepperV(1, Vstep, Vdir);
AccelStepper AccelStepperW(1, Wstep, Wdir);
AccelStepper AccelStepperX(1, Xstep, Xdir);
AccelStepper AccelStepperY(1, Ystep, Ydir);
AccelStepper AccelStepperZ(1, Zstep, Zdir);

//-----------------------------------------
//  TMC5160 config

#define R_SENSE_5160 0.075 // Match to youfr driver
#define R_SENSE_2130 0.11 // Match to your driver
// SilentStepStick series use 0.11
// UltiMachine Einsy and Archim2 boards use 0.2
// Panucatt BSD2660 uses 0.1
// Watterott TMC5160 uses 0.075

int drivertype = 2130;


TMC2130Stepper driverU = TMC2130Stepper(Ucs, R_SENSE_2130);
TMC2130Stepper driverV = TMC2130Stepper(Vcs, R_SENSE_2130);
TMC2130Stepper driverW = TMC2130Stepper(Wcs, R_SENSE_2130);
TMC2130Stepper driverX = TMC2130Stepper(Xcs, R_SENSE_2130);
TMC2130Stepper driverY = TMC2130Stepper(Ycs, R_SENSE_2130);
TMC2130Stepper driverZ = TMC2130Stepper(Zcs, R_SENSE_2130);

//------------------PIN-Definition general--------------------------

const int motorPowerEnable = 20;
const int voltageReadCam = A7;
const int voltageRead1 = A9;
const int voltageRead2 = A8;
const int readCameraTrigger = 15; // Slave-Mode
const int dslrTrigger = 19;
const int dslrFocus = 18;
const int enablePowerUSBhost = 17;
const int csUSBhost = 16;


bool startWithButton = true;
//------------------PIN-Definition general--------------------------
byte autoenabled = false;
byte limitenabled = false;

bool limitEnabledU = false;
bool limitEnabledV = false;
bool limitEnabledW = false;
bool limitEnabledX = false;
bool limitEnabledY = false;
bool limitEnabledZ = false;

long limitStepsU = 0;
long limitStepsV = 0;
long limitStepsW = 0;
long limitStepsX = 0;
long limitStepsY = 0;
long limitStepsZ = 0;

long limitStepsUoffset = 0;
long limitStepsVoffset = 0;
long limitStepsWoffset = 0;
long limitStepsXoffset = 0;
long limitStepsYoffset = 0;
long limitStepsZoffset = 0;

int limitSwitchPinU = 0;
int limitSwitchPinV = 0;
int limitSwitchPinW = 0;
int limitSwitchPinX = 0;
int limitSwitchPinY = 0;
int limitSwitchPinZ = 0;

// Switch conntected to GND
// value = 1 when switch is open
int limitSwitchU_pullup = 0;
int limitSwitchV_pullup = 0;
int limitSwitchW_pullup = 0;
int limitSwitchX_pullup = 0;
int limitSwitchY_pullup = 0;
int limitSwitchZ_pullup = 0;

// Switch conntected to +3.3V
// value = 0 when switch is open
int limitSwitchU_pulldown = 0;
int limitSwitchV_pulldown = 0;
int limitSwitchW_pulldown = 0;
int limitSwitchX_pulldown = 0;
int limitSwitchY_pulldown = 0;
int limitSwitchZ_pulldown = 0;

long limitBackOffU = 0;
long limitBackOffV = 0;
long limitBackOffW = 0;
long limitBackOffX = 0;
long limitBackOffY = 0;
long limitBackOffZ = 0;

bool autoRefRunU = false;
bool autoRefRunV = false;
bool autoRefRunW = false;
bool autoRefRunX = false;
bool autoRefRunY = false;
bool autoRefRunZ = false;

//--------------------------------------------------------

int splinepointamount = 200;
int videobackamount = 1;


byte selectedmode = 0; //0= Timelapse ; 1=Movie

int currentKeyframeU = 0;
int totalKeyframeAmountU = 0;
int currentKeyframeSettingU = 1;
int currentKeyframeV = 0;
int totalKeyframeAmountV = 0;
int currentKeyframeSettingV = 1;
int currentKeyframeW = 0;
int totalKeyframeAmountW = 0;
int currentKeyframeSettingW = 1;
int currentKeyframeX = 0;
int totalKeyframeAmountX = 0;
int currentKeyframeSettingX = 1;
int currentKeyframeY = 0;
int totalKeyframeAmountY = 0;
int currentKeyframeSettingY = 1;
int currentKeyframeZ = 0;
int totalKeyframeAmountZ = 0;
int currentKeyframeSettingZ = 1;

int keyframeAmountU = 0;
int keyframeAmountV = 0;
int keyframeAmountW = 0;
int keyframeAmountX = 0;
int keyframeAmountY = 0;
int keyframeAmountZ = 0;


bool stepperUactive = true;
bool stepperVactive = true;
bool stepperWactive = true;
bool stepperXactive = true;
bool stepperYactive = true;
bool stepperZactive = true;

long stepAmountU = 0;
long stepAmountV = 0;
long stepAmountW = 0;
long stepAmountX = 0;
long stepAmountY = 0;
long stepAmountZ = 0;

unsigned long millisforcalc = 0;
unsigned long millisforcalcPREV = 0;
long durationofcalc = 0;
//-----------Definition Splines----------
Spline tempCurveU;
Spline tempCurveV;
Spline tempCurveW;
Spline tempCurveX;
Spline tempCurveY;
Spline tempCurveZ;


float n_u20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
float u20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

float n_v20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
float v20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

float n_w20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
float w20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

float n_x20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
float x20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

float n_y20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
float y20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

float n_z20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
float z20[40] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};


long tempGerundetU = 0;
long tempGerundetV = 0;
long tempGerundetW = 0;
long tempGerundetX = 0;
long tempGerundetY = 0;
long tempGerundetZ = 0;

//--------Spline-Positions---------


float P4u = 0;
float P4v = 0;
float P4w = 0;
float P4x = 0;
float P4y = 0;
float P4z = 0;

int currentKeyframe = 0;

bool MovieReversed = false;

unsigned long prevTimePStouch;
boolean touchactive = false;

//-------------Defintion Battery-Check-----------------
int returnCamVolt = 0;
int voltage1;
int voltage2;
int voltageCam;

long currentMillisDelay = 0;
long timepassed = 0;

long bildanzahlAKTdslr = 0;
long bildanzahl = 0;
int bildanzahlToGo = 0;
byte runinreverse = 0;
//----------Slave-Input-------------------------
unsigned long lastDebounceTime = 0;
unsigned long debounceDelay = 100; //alter Wert=2

int buttonState = LOW;
int lastButtonState = LOW;

int slaveTrigger = 0;
int slaveTouchbuttonClick = 0;

//------------STEPPER Configuration------------

//Steps for 360° turn
long stepperUres = 200;
long stepperVres = 200;
long stepperWres = 200;
long stepperXres = 200;
long stepperYres = 200;
long stepperZres = 200;

//Set Stepper resolution for setup mode
int UsetupRES = 4;
int VsetupRES = 4;
int WsetupRES = 4;
int XsetupRES = 4;
int YsetupRES = 4;
int ZsetupRES = 4;

// Backlash compensation (Only for reverse play)
int Ubacklash = 0;
int Vbacklash = 0;
int Wbacklash = 0;
int Xbacklash = 0;
int Ybacklash = 0;
int Zbacklash = 0;

// Speed setting for stepper movement
long speedU = 3500;
long speedV = 3500;
long speedW = 3500;
long speedX = 3500;
long speedY = 3500;
long speedZ = 3500;

// Speed setting for stepper movement
long speedUps4 = 0;
long speedVps4 = 0;
long speedWps4 = 0;
long speedXps4 = 0;
long speedYps4 = 0;
long speedZps4 = 0;

// Speed setting for stepper movement
long maxManualSpeedU = 0;
long maxManualSpeedV = 0;
long maxManualSpeedW = 0;
long maxManualSpeedX = 0;
long maxManualSpeedY = 0;
long maxManualSpeedZ = 0;


// Current speed during acceleration (manual move)
long currentSpeedU = 0;
long currentSpeedV = 0;
long currentSpeedW = 0;
long currentSpeedX = 0;
long currentSpeedY = 0;
long currentSpeedZ = 0;

// Invert Direction of axis
int invertDirectionU = 0;
int invertDirectionV = 0;
int invertDirectionW = 0;
int invertDirectionX = 0;
int invertDirectionY = 0;
int invertDirectionZ = 0;


// Acceleration during manual move
int manualAccelU = 300;
int manualAccelV = 300;
int manualAccelW = 300;
int manualAccelX = 300;
int manualAccelY = 300;
int manualAccelZ = 300;



// Acceleration amount for shot-move-shot and pano
long accelerationAmountU = 0;
long accelerationAmountV = 0;
long accelerationAmountW = 0;
long accelerationAmountX = 0;
long accelerationAmountY = 0;
long accelerationAmountZ = 0;


double joystickSpeedU;
double joystickSpeedV;
double joystickSpeedW;
double joystickSpeedX;
double joystickSpeedY;
double joystickSpeedZ;
int joystickSpeedUINT;
int joystickSpeedVINT;
int joystickSpeedWINT;
int joystickSpeedXINT;
int joystickSpeedYINT;
int joystickSpeedZINT;

long constantSpeedU;
long constantSpeedV;
long constantSpeedW;
long constantSpeedX;
long constantSpeedY;
long constantSpeedZ;

long constantSpeedUprev;
long constantSpeedVprev;
long constantSpeedWprev;
long constantSpeedXprev;
long constantSpeedYprev;
long constantSpeedZprev;

long sliderLength = 83000; //full-steps 1,3m
bool resetKeyframes = true;


int manualcontrSpeedU = 50;
int manualcontrSpeedV = 50;
int manualcontrSpeedW = 50;
int manualcontrSpeedX = 50;
int manualcontrSpeedY = 50;
int manualcontrSpeedZ = 50;

//------------------Video-Function----------------

unsigned long currentMillisVidArray = 0;
unsigned long previousMillisVidArray = 0;
unsigned long vidStartMicros = 0;

long posii = 0;
long deltaVidArray = 0;

long videoPointUpdateTime = 40;

long movieLengthSeconds = 0;

long myArrayU[3705];
long myArrayV[3705];
long myArrayW[3705];
long myArrayX[3705];
long myArrayY[3705];
long myArrayZ[3705];

int videoMaxMoveSpeedU = 0;
int videoMaxMoveSpeedV = 0;
int videoMaxMoveSpeedW = 0;
int videoMaxMoveSpeedX = 0;
int videoMaxMoveSpeedY = 0;
int videoMaxMoveSpeedZ = 0;

int accellU = 0;
int accellV = 0;
int accellW = 0;
int accellX = 0;
int accellY = 0;
int accellZ = 0;




//------------------ motionType ------------------
//0: 5-point  -- 1: Linear with Fade -- 2: Linear

int motionTypeU = 0;
int motionTypeV = 0;
int motionTypeW = 0;
int motionTypeX = 0;
int motionTypeY = 0;
int motionTypeZ = 0;


//-----------------TIMELAPSE------------------------

int delayStartSeconds = 0;
int delayStartMill = 0;
int delayStartSecondsPassed = 0;
int delayStartSecondsRemain = 0;

int shotMode = 0; // 0=Slave - 1=Master

long TLinterval = 1000; //interval in ms
int TLdelay = 0; //Verzögerung in ms
int TLmaxexpo = 0;
int TLmaxexpo2 = 0;
int TLmaxexpo3 = 0;
int TLmaxdelay1 = 0;
int TLmaxdelay2 = 0;
int TLmaxdelay3 = 0;
long totalPicNo = 0;
long totalPicNoAKTmoveSpline = 0;
long currentPicNo = 0;
int totalPicNoToGo = 0;
long prozent = 0;
int noMoveShots = 0;
int TLende = 0;
int sliderDIR = 0; // 0 = to Motor - 1 = from Motor
int sliderMODE = 1; // 0 = full lenght - 1 = individual lenght


float VideoDuration = 0;

float totalMovePicNoFLOAT = 0;
int totalMovePicNo = 0;
unsigned long previousMillis2 = 0;
unsigned long previousMillis = 0;

unsigned long SMSdauer = 0;
int SMSstep = 0;

float FADEposition = 0.2; // Fadingposition for linear movement in percent 0.1 = 10 %
float FADEspeed = 0.1; // Fadingspeed for linear movement in percent 0.1 = 10 %

//------------PANO---------------------

long PanoHorizontalMoveSteps = 0;
long PanoVerticalMoveSteps = 0;

int panoRows = 0;
int panoColumns = 0;

int panoCurrentRow = 1;
int panoCurrentColumn = 1;

int panoCurrentPic = 0;
int panoTotalPicAmount = 0;

int PANOstepsX = 0;
int PANOstepsY = 0;

int currentRow = 1;
int currentColumn = 1;
float currentColumnFLOAT = 0;
float currentRowFLOAT = 0;

int ColumnEnd = 1;

int PanoChangeDirectionHori = 1;

int panoNextRow = 0;
//------------current Mode active-------------
bool movehome = false;
boolean moveKeyframe = false;
boolean keyframeMovement = true;
boolean startTL = false;
boolean startMovie = false;
boolean startAstro = false;
boolean startPano = false;
boolean pausePano = false;
boolean pauseTL = false;
boolean startPanoVertical = false;
String panoMode = "";
boolean movieFinished = false;

//------------manual move-------------------
long currentManualSpeed = 0;

long currentManualSpeedU = 0;
long currentManualSpeedV = 0;
long currentManualSpeedW = 0;
long currentManualSpeedX = 0;
long currentManualSpeedY = 0;
long currentManualSpeedZ = 0;

int runU = 0;
int runV = 0;
int runW = 0;
int runX = 0;
int runY = 0;
int runZ = 0;

unsigned long DecelerationMillis;
unsigned long DecelerationMillisPREV;
long moveUdeceleration = 0;
long moveVdeceleration = 0;
long moveWdeceleration = 0;
long moveXdeceleration = 0;
long moveYdeceleration = 0;
long moveZdeceleration = 0;

double decelerationSpeeduDouble = 20;
double decelerationSpeedvDouble = 20;
double decelerationSpeedwDouble = 20;
double decelerationSpeedxDouble = 20;
double decelerationSpeedyDouble = 20;
double decelerationSpeedzDouble = 20;
unsigned int decelerationSpeeduINT = 20;
unsigned int decelerationSpeedvINT = 20;
unsigned int decelerationSpeedwINT = 20;
unsigned int decelerationSpeedxINT = 20;
unsigned int decelerationSpeedyINT = 20;
unsigned int decelerationSpeedzINT = 20;

unsigned int decelerationSpeedALLuINT = 20;
unsigned int decelerationSpeedALLvINT = 20;
unsigned int decelerationSpeedALLwINT = 20;
unsigned int decelerationSpeedALLxINT = 20;
unsigned int decelerationSpeedALLyINT = 20;
unsigned int decelerationSpeedALLzINT = 20;

unsigned int decelerationSpeedManual_uINT = 20;
unsigned int decelerationSpeedManual_vINT = 20;
unsigned int decelerationSpeedManual_wINT = 20;
unsigned int decelerationSpeedManual_xINT = 20;
unsigned int decelerationSpeedManual_yINT = 20;
unsigned int decelerationSpeedManual_zINT = 20;

unsigned int decelerationSpeedManualALL = 999;

int currentSelectedKeyframe = 0;
String currentSelectedAxis = "A";
boolean keyframeStartnew = true;
boolean keyframe1new = true;
boolean keyframe2new = true;
boolean keyframe3new = true;
boolean keyframeEndnew = true;

//-----------ASTRO--------------------
unsigned long AstroUpdateInterval = 8543; // update interval of steps in [micros]
byte AstroStartDelay = 3; // delay time before first picture after start in [s]
unsigned int AstroExpoTime01 = 1; // HDR1 exposure time in [s]
unsigned int AstroExpoTime02 = 0; // HDR2 exposure time in [s]
unsigned int AstroExpoTime03 = 0; // HDR3 exposure time in [s]
unsigned int AstroExpo01delay = 3; // delay after HDR1 exposure in [s]
unsigned int AstroExpo02delay = 0; // delay after HDR2 exposure in [s]
unsigned int AstroExpo03delay = 0; // delay after HDR3 exposure in [s]
unsigned int AstroPicRepete = 10;
unsigned int AstroPicCurrentRepeat = 0;
bool astroPicActive = false;
int AstroObject = 0;

//-------------Manual move---------------
int currentSpeedU02 = 0;
int lastSpeedU = 0;
int lastSpeedU02 = 0;

int currentSpeedV02 = 0;
int lastSpeedV = 0;
int lastSpeedV02 = 0;

int currentSpeedW02 = 0;
int lastSpeedW = 0;
int lastSpeedW02 = 0;

int currentSpeedX02 = 0;
int lastSpeedX = 0;
int lastSpeedX02 = 0;

int currentSpeedY02 = 0;
int lastSpeedY = 0;
int lastSpeedY02 = 0;

int currentSpeedZ02 = 0;
int lastSpeedZ = 0;
int lastSpeedZ02 = 0;


//--------------PS4-controller-speeds----------------
// Speed setting for stepper movement
double speedUd = 7000;
double  speedVd = 7000;
double speedWd = 7000;
double  speedXd = 7000;
double  speedYd = 7000;
double  speedZd = 7000;

int controlSpeed = 10;

double speedFactor = 1;

void setup()
{

  delay(500);
  //---------Accelstepper-Pins--------------
  pinMode(13, OUTPUT);
  digitalWrite(13, HIGH);

  /*
    pinMode(44, OUTPUT);
    digitalWrite(44, HIGH);
  */
  pinMode(Ustep, OUTPUT);
  pinMode(Udir, OUTPUT);
  pinMode(Vstep, OUTPUT);
  pinMode(Vdir, OUTPUT);
  pinMode(Wstep, OUTPUT);
  pinMode(Wdir, OUTPUT);
  pinMode(Xstep, OUTPUT);
  pinMode(Xdir, OUTPUT);
  pinMode(Ystep, OUTPUT);
  pinMode(Ydir, OUTPUT);
  pinMode(Zstep, OUTPUT);
  pinMode(Zdir, OUTPUT);
  pinMode (enablePowerUSBhost, OUTPUT);
  pinMode (csUSBhost, OUTPUT);

  delay(200);
  digitalWrite(enablePowerUSBhost, HIGH);
  digitalWrite(csUSBhost, HIGH);
  delay(200);

  pinMode(Uenable, OUTPUT);
  pinMode(Venable, OUTPUT);
  pinMode(Wenable, OUTPUT);
  pinMode(Xenable, OUTPUT);
  pinMode(Yenable, OUTPUT);
  pinMode(Zenable, OUTPUT);


  pinMode (readCameraTrigger, INPUT);

  pinMode (voltageRead1, INPUT);
  pinMode (voltageRead2, INPUT);
  pinMode (voltageCam, INPUT);

  pinMode (dslrTrigger, OUTPUT);
  pinMode (dslrFocus, OUTPUT);

  pinMode(motorPowerEnable, OUTPUT);
  digitalWrite(motorPowerEnable, LOW);
  digitalWrite(dslrTrigger, LOW);
  digitalWrite(dslrFocus, LOW);

  digitalWrite(Uenable, HIGH);
  digitalWrite(Venable, HIGH);
  digitalWrite(Wenable, HIGH);
  digitalWrite(Xenable, HIGH);
  digitalWrite(Yenable, HIGH);
  digitalWrite(Zenable, HIGH);

#if !defined(__MIPSEL__)
  // while (!Serial); // Wait for serial port to connect - used on Leonardo, Teensy and other boards with built-in USB CDC serial connection
#endif
  if (Usb.Init() == -1) {
    //  Serial.print(F("\r\nOSC did not start"));
    while (1); //halt
  }





  if (drivertype == 5160) {
    TMC5160Stepper driverU = TMC5160Stepper(Ucs, R_SENSE_5160);
    TMC5160Stepper driverV = TMC5160Stepper(Vcs, R_SENSE_5160);
    TMC5160Stepper driverW = TMC5160Stepper(Wcs, R_SENSE_5160);
    TMC5160Stepper driverX = TMC5160Stepper(Xcs, R_SENSE_5160);
    TMC5160Stepper driverY = TMC5160Stepper(Ycs, R_SENSE_5160);
    TMC5160Stepper driverZ = TMC5160Stepper(Zcs, R_SENSE_5160);
  }
  //disable drivers
  setUmode(0);
  setVmode(0);
  setWmode(0);
  setXmode(0);
  setYmode(0);
  setZmode(0);


  analogReadResolution(13);

  AccelStepperU.setMaxSpeed(speedU);
  AccelStepperV.setMaxSpeed(speedV);
  AccelStepperW.setMaxSpeed(speedW);
  AccelStepperX.setMaxSpeed(speedX);
  AccelStepperY.setMaxSpeed(speedY);
  AccelStepperZ.setMaxSpeed(speedZ);

  //set minimum pulse width to 4 µs
  AccelStepperU.setMinPulseWidth(4);
  AccelStepperV.setMinPulseWidth(4);
  AccelStepperW.setMinPulseWidth(4);
  AccelStepperX.setMinPulseWidth(4);
  AccelStepperY.setMinPulseWidth(4);
  AccelStepperZ.setMinPulseWidth(4);



  Serial.begin(19200);

  Serial5.begin(9600);

  Serial5.flush();


  pinMode(Ucs, OUTPUT);
  digitalWrite(Ucs, HIGH);
  pinMode(Vcs, OUTPUT);
  digitalWrite(Vcs, HIGH);
  pinMode(Wcs, OUTPUT);
  digitalWrite(Wcs, HIGH);
  pinMode(Xcs, OUTPUT);
  digitalWrite(Xcs, HIGH);
  pinMode(Ycs, OUTPUT);
  digitalWrite(Ycs, HIGH);
  pinMode(Zcs, OUTPUT);
  digitalWrite(Zcs, HIGH);






  SPI.begin();


  previousMillisVidArray = millis();



  /*
    AccelStepperX.setMaxSpeed(800); // 100mm/s @ 80 steps/mm
    AccelStepperX.setAcceleration(800); // 2000mm/s^2
    AccelStepperX.moveTo(-300);



    AccelStepperY.setMaxSpeed(800); // 100mm/s @ 80 steps/mm
    AccelStepperY.setAcceleration(800); // 2000mm/s^2
    AccelStepperY.moveTo(-500);
  */


}

int sttep = 0;

void loop()
{





  /*
    if (AccelStepperX.distanceToGo() == 0) {

    //delay(5000);
    AccelStepperX.moveTo(-AccelStepperX.currentPosition()); // Move 100mm

    }

    if (AccelStepperY.distanceToGo() == 0) {

    //delay(5000);
    AccelStepperY.moveTo(-AccelStepperY.currentPosition()); // Move 100mm

    }
    AccelStepperX.run();
    AccelStepperY.run();
  */


  if (runU == 2 || runV == 2 || runW == 2 || runX == 2 || runY == 2 || runZ == 2) {

    //---------------manual move---------------------
    //------Run U------



    if (runU == 2) {

      if (limitEnabledU == false) {



        if (softJoystickUactive == true) {
          softJoystickU(joystickSpeedUINT);
        }

        if (constantspeedUactive == true) {
          speedcontrolU(constantSpeedU);
        }


        AccelStepperU.setSpeed(currentSpeedU);
        AccelStepperU.runSpeed();
      }
      else {



        int buttonState = digitalRead(limitSwitchPinU);

        if (buttonState == 0) {

          if (AccelStepperU.currentPosition() < (limitStepsU - limitStepsUoffset)) {
            AccelStepperU.setSpeed(currentSpeedU);
            AccelStepperU.runSpeed();
            /*
              if (millis() - prevmillmovv > 1) {
                 Serial.println(AccelStepperX.currentPosition());
                 prevmillmovv = millis();
               }
            */
          }
          else {
            switchreached = false;
            AccelStepperU.stop();
            StringSend = "#limitu_0$";
            Serial5.print(StringSend);
            // Serial.println(StringSend);
            long prevmill;
            long newPosiii = AccelStepperU.currentPosition() - limitBackOffU;
            while (switchreached == false) {
              /*
                          if (millis() - prevmill > 1) {
                            Serial.print(newPosiii);
                            Serial.print(";");
                            Serial.println(AccelStepperX.currentPosition());
                            prevmill = millis();
                          }
              */


              AccelStepperU.moveTo(newPosiii);
              AccelStepperU.run();

              if (AccelStepperU.currentPosition() == newPosiii) {
                switchreached = true;
                //  Serial.println("reaaaaach");
                reachedtime = millis();
              }

            }
            runU = 0;
            currentSpeedU = 0;
          }
        }
        else {
          switchreached = false;
          AccelStepperU.stop();
          StringSend = "#limitu_0$";
          Serial5.print(StringSend);
          // Serial.println(StringSend);
          long prevmill;
          long newPosiii = AccelStepperU.currentPosition() + limitBackOffU;
          while (switchreached == false) {
            /*
                      if (millis() - prevmill > 1) {
                        Serial.print(newPosiii);
                        Serial.print(";");
                        Serial.println(AccelStepperX.currentPosition());
                        prevmill = millis();
                      }
            */


            AccelStepperU.moveTo(newPosiii);
            AccelStepperU.run();

            if (AccelStepperU.currentPosition() == newPosiii) {
              switchreached = true;
              //   Serial.println("reaaaaach");
              reachedtime = millis();
            }

          }
          runU = 0;
          currentSpeedU = 0;
        }
      }
    }
    //------Run V------

    if (runV == 2) {

      if (limitEnabledV == false) {

       if (softJoystickVactive == true) {
          softJoystickV(joystickSpeedVINT);
        }

        if (constantspeedVactive == true) {
          speedcontrolV(constantSpeedV);
        }
        AccelStepperV.setSpeed(currentSpeedV);
        AccelStepperV.runSpeed();
      }
      else {


        int buttonState = digitalRead(limitSwitchPinV);

        if (buttonState == 0) {


          if (AccelStepperV.currentPosition() < (limitStepsV - limitStepsVoffset)) {
            AccelStepperV.setSpeed(currentSpeedV);
            AccelStepperV.runSpeed();
            /*
              if (millis() - prevmillmovv > 1) {

                 Serial.println(AccelStepperX.currentPosition());
                 prevmillmovv = millis();
               }
            */
          }
          else {
            switchreached = false;
            AccelStepperV.stop();
            StringSend = "#limitv_0$";
            Serial5.print(StringSend);
            // Serial.println(StringSend);
            long prevmill;
            long newPosiii = AccelStepperV.currentPosition() - limitBackOffV;
            while (switchreached == false) {
              /*
                          if (millis() - prevmill > 1) {
                            Serial.print(newPosiii);
                            Serial.print(";");
                            Serial.println(AccelStepperX.currentPosition());
                            prevmill = millis();
                          }
              */


              AccelStepperV.moveTo(newPosiii);
              AccelStepperV.run();

              if (AccelStepperV.currentPosition() == newPosiii) {
                switchreached = true;
                //  Serial.println("reaaaaach");
                reachedtime = millis();
              }

            }
            runV = 0;
            currentSpeedV = 0;
          }
        }
        else {
          switchreached = false;
          AccelStepperV.stop();
          StringSend = "#limitv_0$";
          Serial5.print(StringSend);
          // Serial.println(StringSend);
          long prevmill;
          long newPosiii = AccelStepperV.currentPosition() + limitBackOffV;
          while (switchreached == false) {
            /*
                      if (millis() - prevmill > 1) {
                        Serial.print(newPosiii);
                        Serial.print(";");
                        Serial.println(AccelStepperX.currentPosition());
                        prevmill = millis();
                      }
            */


            AccelStepperV.moveTo(newPosiii);
            AccelStepperV.run();

            if (AccelStepperV.currentPosition() == newPosiii) {
              switchreached = true;
              //   Serial.println("reaaaaach");
              reachedtime = millis();
            }

          }
          runV = 0;
          currentSpeedV = 0;
        }
      }
    }
    //------Run W------

    if (runW == 2) {

      if (limitEnabledW == false) {

        if (softJoystickWactive == true) {
          softJoystickW(joystickSpeedWINT);
        }

        if (constantspeedWactive == true) {
          speedcontrolW(constantSpeedW);
        }
        AccelStepperW.setSpeed(currentSpeedW);
        AccelStepperW.runSpeed();
      }
      else {

        int buttonState = digitalRead(limitSwitchPinW);

        if (buttonState == 0) {


          if (AccelStepperW.currentPosition() < (limitStepsW - limitStepsWoffset)) {
            AccelStepperW.setSpeed(currentSpeedW);
            AccelStepperW.runSpeed();
            /*
              if (millis() - prevmillmovv > 1) {

                 Serial.println(AccelStepperX.currentPosition());
                 prevmillmovv = millis();
               }
            */
          }
          else {
            switchreached = false;
            AccelStepperW.stop();
            StringSend = "#limitw_0$";
            Serial5.print(StringSend);
            // Serial.println(StringSend);
            long prevmill;
            long newPosiii = AccelStepperW.currentPosition() - limitBackOffW;
            while (switchreached == false) {
              /*
                          if (millis() - prevmill > 1) {
                            Serial.print(newPosiii);
                            Serial.print(";");
                            Serial.println(AccelStepperX.currentPosition());
                            prevmill = millis();
                          }
              */


              AccelStepperW.moveTo(newPosiii);
              AccelStepperW.run();

              if (AccelStepperW.currentPosition() == newPosiii) {
                switchreached = true;
                //  Serial.println("reaaaaach");
                reachedtime = millis();
              }

            }
            runW = 0;
            currentSpeedW = 0;
          }
        }
        else {
          switchreached = false;
          AccelStepperW.stop();
          StringSend = "#limitw_0$";
          Serial5.print(StringSend);
          // Serial.println(StringSend);
          long prevmill;
          long newPosiii = AccelStepperW.currentPosition() + limitBackOffW;
          while (switchreached == false) {
            /*
                      if (millis() - prevmill > 1) {
                        Serial.print(newPosiii);
                        Serial.print(";");
                        Serial.println(AccelStepperX.currentPosition());
                        prevmill = millis();
                      }
            */


            AccelStepperW.moveTo(newPosiii);
            AccelStepperW.run();

            if (AccelStepperW.currentPosition() == newPosiii) {
              switchreached = true;
              //   Serial.println("reaaaaach");
              reachedtime = millis();
            }

          }
          runW = 0;
          currentSpeedW = 0;
        }
      }
    }
    //------Run X------

    if (runX == 2) {

      if (limitEnabledX == false) {

        if (softJoystickXactive == true) {
          softJoystickX(joystickSpeedXINT);
        }

        if (constantspeedXactive == true) {
          speedcontrolX(constantSpeedX);
        }

        AccelStepperX.setSpeed(currentSpeedX);
        AccelStepperX.runSpeed();
      }
      else {

        int buttonState = digitalRead(limitSwitchPinX);

        if (buttonState == 0) {


          if (AccelStepperX.currentPosition() < (limitStepsX - limitStepsXoffset)) {
            AccelStepperX.setSpeed(currentSpeedX);
            AccelStepperX.runSpeed();
            /*
              if (millis() - prevmillmovv > 1) {

                 Serial.println(AccelStepperX.currentPosition());
                 prevmillmovv = millis();
               }
            */
          }
          else {
            switchreached = false;
            AccelStepperX.stop();
            StringSend = "#limitx_0$";
            Serial5.print(StringSend);
            // Serial.println(StringSend);
            long prevmill;
            long newPosiii = AccelStepperX.currentPosition() - limitBackOffX;
            while (switchreached == false) {
              /*
                          if (millis() - prevmill > 1) {
                            Serial.print(newPosiii);
                            Serial.print(";");
                            Serial.println(AccelStepperX.currentPosition());
                            prevmill = millis();
                          }
              */


              AccelStepperX.moveTo(newPosiii);
              AccelStepperX.run();

              if (AccelStepperX.currentPosition() == newPosiii) {
                switchreached = true;
                //  Serial.println("reaaaaach");
                reachedtime = millis();
              }

            }
            runX = 0;
            currentSpeedX = 0;
          }
        }
        else {
          switchreached = false;
          AccelStepperX.stop();
          StringSend = "#limitx_0$";
          Serial5.print(StringSend);
          // Serial.println(StringSend);
          long prevmill;
          long newPosiii = AccelStepperX.currentPosition() + limitBackOffX;
          while (switchreached == false) {
            /*
                      if (millis() - prevmill > 1) {
                        Serial.print(newPosiii);
                        Serial.print(";");
                        Serial.println(AccelStepperX.currentPosition());
                        prevmill = millis();
                      }
            */


            AccelStepperX.moveTo(newPosiii);
            AccelStepperX.run();

            if (AccelStepperX.currentPosition() == newPosiii) {
              switchreached = true;
              //   Serial.println("reaaaaach");
              reachedtime = millis();
            }

          }
          runX = 0;
          currentSpeedX = 0;
        }
      }
    }
    //------Run Y------

    if (runY == 2) {

      if (limitEnabledY == false) {


        if (softJoystickYactive == true) {
          softJoystickY(joystickSpeedYINT);
        }

        if (constantspeedYactive == true) {
          speedcontrolY(constantSpeedY);
        }

        AccelStepperY.setSpeed(currentSpeedY);
        AccelStepperY.runSpeed();
      }
      else {

        int buttonState = digitalRead(limitSwitchPinY);

        if (buttonState == 0) {


          if (AccelStepperY.currentPosition() < (limitStepsY - limitStepsYoffset)) {
            AccelStepperY.setSpeed(currentSpeedY);
            AccelStepperY.runSpeed();
            /*
              if (millis() - prevmillmovv > 1) {

                 Serial.println(AccelStepperX.currentPosition());
                 prevmillmovv = millis();
               }
            */
          }
          else {
            switchreached = false;
            AccelStepperY.stop();
            StringSend = "#limity_0$";
            Serial5.print(StringSend);
            // Serial.println(StringSend);
            long prevmill;
            long newPosiii = AccelStepperY.currentPosition() - limitBackOffY;
            while (switchreached == false) {
              /*
                          if (millis() - prevmill > 1) {
                            Serial.print(newPosiii);
                            Serial.print(";");
                            Serial.println(AccelStepperX.currentPosition());
                            prevmill = millis();
                          }
              */


              AccelStepperY.moveTo(newPosiii);
              AccelStepperY.run();

              if (AccelStepperY.currentPosition() == newPosiii) {
                switchreached = true;
                //  Serial.println("reaaaaach");
                reachedtime = millis();
              }

            }
            runY = 0;
            currentSpeedY = 0;
          }
        }
        else {
          switchreached = false;
          AccelStepperY.stop();
          StringSend = "#limity_0$";
          Serial5.print(StringSend);
          // Serial.println(StringSend);
          long prevmill;
          long newPosiii = AccelStepperY.currentPosition() + limitBackOffY;
          while (switchreached == false) {
            /*
                      if (millis() - prevmill > 1) {
                        Serial.print(newPosiii);
                        Serial.print(";");
                        Serial.println(AccelStepperX.currentPosition());
                        prevmill = millis();
                      }
            */


            AccelStepperY.moveTo(newPosiii);
            AccelStepperY.run();

            if (AccelStepperY.currentPosition() == newPosiii) {
              switchreached = true;
              //   Serial.println("reaaaaach");
              reachedtime = millis();
            }

          }
          runY = 0;
          currentSpeedY = 0;
        }
      }
    }
    //------Run Z------

    if (runZ == 2) {

      if (limitEnabledZ == false) {

        if (softJoystickZactive == true) {
          softJoystickZ(joystickSpeedZINT);
        }

        if (constantspeedZactive == true) {
          speedcontrolZ(constantSpeedZ);
        }

        AccelStepperZ.setSpeed(currentSpeedZ);
        AccelStepperZ.runSpeed();
      }
      else {


        int buttonState = digitalRead(limitSwitchPinZ);

        if (buttonState == 0) {


          if (AccelStepperZ.currentPosition() < (limitStepsZ - limitStepsZoffset)) {
            AccelStepperZ.setSpeed(currentSpeedZ);
            AccelStepperZ.runSpeed();

            Serial.print(limitStepsZ);
            Serial.print(";");
            Serial.println(limitStepsZoffset);
            /*
              if (millis() - prevmillmovv > 1) {

                 Serial.println(AccelStepperX.currentPosition());
                 prevmillmovv = millis();
               }
            */
          }
          else {
            switchreached = false;
            AccelStepperZ.stop();
            StringSend = "#limitz_0$";
            Serial5.print(StringSend);
            Serial.println(StringSend);
            long prevmill;
            long newPosiii = AccelStepperZ.currentPosition() - limitBackOffZ;
            while (switchreached == false) {
              /*
                          if (millis() - prevmill > 1) {
                            Serial.print(newPosiii);
                            Serial.print(";");
                            Serial.println(AccelStepperX.currentPosition());
                            prevmill = millis();
                          }
              */


              AccelStepperZ.moveTo(newPosiii);
              AccelStepperZ.run();

              if (AccelStepperZ.currentPosition() == newPosiii) {
                switchreached = true;
                //  Serial.println("reaaaaach");
                reachedtime = millis();
              }

            }
            runZ = 0;
            currentSpeedZ = 0;
          }
        }
        else {
          switchreached = false;
          AccelStepperZ.stop();
          StringSend = "#limitz_0$";
          Serial5.print(StringSend);
          Serial.println(StringSend);
          long prevmill;
          long newPosiii = AccelStepperZ.currentPosition() + limitBackOffZ;
          while (switchreached == false) {
            /*
                      if (millis() - prevmill > 1) {
                        Serial.print(newPosiii);
                        Serial.print(";");
                        Serial.println(AccelStepperX.currentPosition());
                        prevmill = millis();
                      }
            */


            AccelStepperZ.moveTo(newPosiii);
            AccelStepperZ.run();

            if (AccelStepperZ.currentPosition() == newPosiii) {
              switchreached = true;
              //   Serial.println("reaaaaach");
              reachedtime = millis();
            }

          }
          runZ = 0;
          currentSpeedZ = 0;
        }
      }
    }
  }
  else if (moveKeyframe == false && movehome == false && startAstro == false && startPano == false && startPanoVertical == false && startTL == false && startMovie == false) {
    PS4controllerfunction();
    //    Serial.println("2222");
    if (startWithButton == true) {

      if ((millis() - lastDebounceTime) > debounceDelay) {
        slaveTrigger = digitalRead(readCameraTrigger);
        // Serial.println("read read Button");
        if (slaveTrigger == 1) {

          lastDebounceTime = millis();
          previousMillisVidArray = micros();
          currentMillisVidArray = micros();
          vidStartMicros = micros();
          startMovie = true;
          MovieReversed = false;
          posii = 0;
          Serial.println("start Movie Button");
        }
      }
    }
  }
  else {
    //  Serial.println("PS4disconnect1");
    //  PS4disconnect();
    if (startAstro == true) {
      astroloop();
    }
    if (movehome == true) {

      Serial.println("movehomemovehome");
      setMaxSpeedSteppers();
      moveBackToStart();

    }

    if (moveKeyframe == true) {
      //  Serial.println("movekeyframe");
      setMaxSpeedSteppers();
      AccelStepperU.moveTo(stepAmountU);
      AccelStepperV.moveTo(stepAmountV);
      AccelStepperW.moveTo(stepAmountW);
      AccelStepperX.moveTo(stepAmountX);
      AccelStepperY.moveTo(stepAmountY);
      AccelStepperZ.moveTo(stepAmountZ);
      moveToKeyframe();

    }




    if (startTL == true) {


      unsigned long currentMillis = millis();

      if (delayStartSeconds == 0) {
        timelapseMaster();
      }

      else {
        if (currentMillis - timepassed > 1000) {
          delayStartSecondsPassed++;
          delayStartSecondsRemain = delayStartSeconds - delayStartSecondsPassed;

          myString = String(delayStartSecondsRemain);
          StringSend = "#delayStartRe_" + myString + "$";
          Serial5.print(StringSend);
          // Serial.println(StringSend);

          if (delayStartSecondsPassed == delayStartSeconds) {
            delay(50);
            StringSend = "#delayStartRe_0$" ;
            Serial5.print(StringSend);
            delay(50);
            delayStartSeconds = 0;
          }
          timepassed = currentMillis;
        }
      }

    }



    if (startMovie == true) {
      if (MovieReversed == false) {
        Splinevideoloop();
      }
      else {
        Serial.print("posimovie:");
        Serial.println(posii);
        posii = splinepointamount;
        while (startMovie == true) {

          SplinevideoloopReverse();
        }
      }

    }


    if (startPano == true) {
      PanoLoop();
    }
    if (startPanoVertical == true) {
      PanoLoopVertical();
    }


  }

  if (Serial5.available()) {

    char c = Serial5.read();

    if (c == '#') {
      parseCommand(commandStr);
      Serial.println(commandStr);
      commandStr = "";
    }
    else {
      commandStr += c;
    }
  }






}


void parseCommand(String com) {
  //  Serial.println(com);
  String part1;
  String part2;
  int no;

  part1 = com.substring(0, com.indexOf("_"));
  part2 = com.substring(com.indexOf("_") + 1, com.length());

  no = part1.toInt();
  readBT(no, part2);

}



void readBT(int BTvar, String BTvalue)
{

  switch (BTvar) {
    case 1:


      Serial.println(BTvalue);
      tpart1_joyLeftXaxis = BTvalue.charAt(0);
      tpart2_joyLeftYaxis = BTvalue.charAt(1);
      tpart3_joyRightXaxis = BTvalue.charAt(2);
      tpart4_joyRightYaxis = BTvalue.charAt(3);
      tpart5_joyLeftXposi = BTvalue.substring(BTvalue.indexOf("&") + 1, BTvalue.indexOf("$"));
      tpart6_joyLeftYposi = BTvalue.substring(BTvalue.indexOf("$") + 1, BTvalue.indexOf("?"));
      tpart7_joyRightXposi = BTvalue.substring(BTvalue.indexOf("?") + 1, BTvalue.indexOf("+"));
      tpart8_joyRightYposi = BTvalue.substring(BTvalue.indexOf("+") + 1, BTvalue.length());


      joyLeftXaxis = tpart1_joyLeftXaxis.toInt();
      joyLeftYaxis = tpart2_joyLeftYaxis.toInt();
      joyRightXaxis = tpart3_joyRightXaxis.toInt();
      joyRightYaxis = tpart4_joyRightYaxis.toInt();


      softwarejoystickinput(joyLeftXaxis, tpart5_joyLeftXposi.toInt());
      softwarejoystickinput(joyLeftYaxis, tpart6_joyLeftYposi.toInt());
      softwarejoystickinput(joyRightXaxis, tpart7_joyRightXposi.toInt());
      softwarejoystickinput(joyRightYaxis, tpart8_joyRightYposi.toInt());


      break;

    case 10:
      constantspeedUactive = true;
      constantSpeedU = BTvalue.toInt();
      constantSpeedUprev = constantSpeedU;
      runU = 2;



      if (decelerationSpeedManualALL == 999) {
        decelerationSpeedManual_uINT = decelerationSpeeduINT;
      }
      else {
        decelerationSpeeduDouble = (decelerationSpeedManualALL * 1000 / constantSpeedUprev) + 0.5 ;
        decelerationSpeedManual_uINT = (int)decelerationSpeeduDouble;
      }
      break;

    case 11:
      constantspeedVactive = true;
      constantSpeedV = BTvalue.toInt();
      constantSpeedVprev = constantSpeedV;
      runV = 2;

      if (decelerationSpeedManualALL == 999) {
        decelerationSpeedManual_vINT = decelerationSpeedvINT;
      }
      else {
        decelerationSpeedvDouble = (decelerationSpeedManualALL * 1000 / constantSpeedVprev) + 0.5 ;
        decelerationSpeedManual_vINT = (int)decelerationSpeedvDouble;
      }
      break;

    case 12:
      constantspeedWactive = true;
      constantSpeedW = BTvalue.toInt();
      constantSpeedWprev = constantSpeedW;
      runW = 2;

      if (decelerationSpeedManualALL == 999) {
        decelerationSpeedManual_wINT = decelerationSpeedwINT;
      }
      else {
        decelerationSpeedwDouble = (decelerationSpeedManualALL * 1000 / constantSpeedWprev) + 0.5 ;
        decelerationSpeedManual_wINT = (int)decelerationSpeedwDouble;
      }
      break;

    case 13:
      constantspeedXactive = true;
      constantSpeedX = BTvalue.toInt();
      constantSpeedXprev = constantSpeedX;
      runX = 2;

      if (decelerationSpeedManualALL == 999) {
        decelerationSpeedManual_xINT = decelerationSpeedxINT;
      }
      else {
        decelerationSpeedxDouble = (decelerationSpeedManualALL * 1000 / constantSpeedXprev) + 0.5 ;
        decelerationSpeedManual_xINT = (int)decelerationSpeedxDouble;
      }
      break;
    case 14:
      constantspeedYactive = true;
      constantSpeedY = BTvalue.toInt();
      constantSpeedYprev = constantSpeedY;
      runY = 2;

      if (decelerationSpeedManualALL == 999) {
        decelerationSpeedManual_yINT = decelerationSpeedyINT;
      }
      else {
        decelerationSpeedyDouble = (decelerationSpeedManualALL * 1000 / constantSpeedYprev) + 0.5 ;
        decelerationSpeedManual_yINT = (int)decelerationSpeedyDouble;
      }
      break;

    case 15:
      constantspeedZactive = true;
      constantSpeedZ = BTvalue.toInt();
      constantSpeedZprev = constantSpeedZ;
      runZ = 2;

      if (decelerationSpeedManualALL == 999) {
        decelerationSpeedManual_zINT = decelerationSpeedzINT;
      }
      else {
        decelerationSpeedzDouble = (decelerationSpeedManualALL * 1000 / constantSpeedZprev) + 0.5 ;
        decelerationSpeedManual_zINT = (int)decelerationSpeedzDouble;
      }
      break;

    case 16:


      constantSpeedU = 0;
      constantSpeedV = 0;
      constantSpeedW = 0;
      constantSpeedX = 0;
      constantSpeedY = 0;
      constantSpeedZ = 0;

      break;

    case 17:


      Serial.print("constantSpeedXprev:");
      Serial.print(constantSpeedXprev);
      Serial.print("constantSpeedYprev:");
      Serial.println(constantSpeedYprev);

      constantSpeedU = constantSpeedUprev;
      constantSpeedV = constantSpeedVprev;
      constantSpeedW = constantSpeedWprev;
      constantSpeedX = constantSpeedXprev;
      constantSpeedY = constantSpeedYprev;
      constantSpeedZ = constantSpeedZprev;
      constantspeedUactive = true;
      constantspeedVactive = true;
      constantspeedWactive = true;
      constantspeedXactive = true;
      constantspeedYactive = true;
      constantspeedZactive = true;
      runU = 2;
      runV = 2;
      runW = 2;
      runX = 2;
      runY = 2;
      runZ = 2;
      break;


    case 1001:

      if (BTvalue == "1") {
        StepperEnable();
        delay(50);
        StepperEnable();
        delay(50);



      }
      if (BTvalue == "0") {
        StepperStop();
      }
      if (BTvalue == "2") {
        startTL = false;
        TLende = 0;
        currentPicNo = 0;
        totalPicNoAKTmoveSpline = 0;
        panoCurrentPic = panoTotalPicAmount;
      }

      break;

    case 1002:
      PS4.pair();
      break;

    case 1003:
      PS4disconnect();
      Serial.println("PS4disconnect2");
      break;

    case 1007:
      if (switchreached == true) {
        currentManualSpeed = 0;
        switchreached = false;
      }
      else if ((millis() - reachedtime) > 500) {
        currentManualSpeed = BTvalue.toInt();

        if (currentManualSpeed == 0) {

          while (currentSpeedU != 0) {
            DecelerationMillis = micros();


            if (currentSpeedU > 0) {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeeduINT)
              {

                currentSpeedU--;
                DecelerationMillisPREV = micros();
              }
            }
            else {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeeduINT)
              {

                currentSpeedU++;
                DecelerationMillisPREV = micros();
              }
            }
            AccelStepperU.setSpeed(currentSpeedU);
            AccelStepperU.runSpeed();

          }


          runU = 0;
          currentSpeedU = 0;

          AccelStepperU.setSpeed(speedU);

          myString = String(AccelStepperU.currentPosition());
          StringSend = "#curPosU_" + myString + "$";
          Serial5.print(StringSend);
          Serial.print("currentKeyframeSettingU:");
          Serial.println(currentKeyframeSettingU);
          if (currentKeyframeSettingU == 1) {
            limitStepsUoffset = limitStepsUoffset + AccelStepperU.currentPosition();

            Serial.print("limitStepsUoffset");
            Serial.println(limitStepsUoffset);
            AccelStepperU.setCurrentPosition(0);
          }


        }
        else {
          currentSpeedU = currentManualSpeed;
          lastSpeedU02 = currentManualSpeed;
          runU = 2;
        }
      }
      break;

    case 1008:
      if (switchreached == true) {
        currentManualSpeed = 0;
        switchreached = false;
      }
      else if ((millis() - reachedtime) > 500) {
        currentManualSpeed = BTvalue.toInt();

        if (currentManualSpeed == 0) {

          while (currentSpeedV != 0) {
            DecelerationMillis = micros();


            if (currentSpeedV > 0) {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedvINT)
              {

                currentSpeedV--;
                DecelerationMillisPREV = micros();
              }
            }
            else {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedvINT)
              {

                currentSpeedV++;
                DecelerationMillisPREV = micros();
              }
            }
            AccelStepperV.setSpeed(currentSpeedV);
            AccelStepperV.runSpeed();

          }


          runV = 0;
          currentSpeedV = 0;

          AccelStepperV.setSpeed(speedV);

          myString = String(AccelStepperV.currentPosition());
          StringSend = "#curPosV_" + myString + "$";
          Serial5.print(StringSend);
          Serial.print("currentKeyframeSettingV:");
          Serial.println(currentKeyframeSettingV);
          if (currentKeyframeSettingV == 1) {
            limitStepsVoffset = limitStepsVoffset + AccelStepperV.currentPosition();

            Serial.print("limitStepsVoffset");
            Serial.println(limitStepsVoffset);
            AccelStepperV.setCurrentPosition(0);
          }


        }
        else {
          currentSpeedV = currentManualSpeed;
          lastSpeedV02 = currentManualSpeed;
          runV = 2;
        }
      }
      break;

    case 1009:
      if (switchreached == true) {
        currentManualSpeed = 0;
        switchreached = false;
      }
      else if ((millis() - reachedtime) > 500) {
        currentManualSpeed = BTvalue.toInt();

        if (currentManualSpeed == 0) {

          while (currentSpeedW != 0) {
            DecelerationMillis = micros();


            if (currentSpeedW > 0) {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedwINT)
              {

                currentSpeedW--;
                DecelerationMillisPREV = micros();
              }
            }
            else {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedwINT)
              {

                currentSpeedW++;
                DecelerationMillisPREV = micros();
              }
            }
            AccelStepperW.setSpeed(currentSpeedW);
            AccelStepperW.runSpeed();

          }


          runW = 0;
          currentSpeedW = 0;

          AccelStepperW.setSpeed(speedW);

          myString = String(AccelStepperW.currentPosition());
          StringSend = "#curPosW_" + myString + "$";
          Serial5.print(StringSend);
          Serial.print("currentKeyframeSettingW:");
          Serial.println(currentKeyframeSettingW);
          if (currentKeyframeSettingW == 1) {
            limitStepsWoffset = limitStepsWoffset + AccelStepperW.currentPosition();

            Serial.print("limitStepsWoffset");
            Serial.println(limitStepsWoffset);
            AccelStepperW.setCurrentPosition(0);
          }


        }
        else {
          currentSpeedW = currentManualSpeed;
          lastSpeedW02 = currentManualSpeed;
          runW = 2;
        }
      }
      break;



    case 1010:
      if (switchreached == true) {
        currentManualSpeed = 0;
        switchreached = false;
      }
      else if ((millis() - reachedtime) > 500) {
        currentManualSpeed = BTvalue.toInt();

        if (currentManualSpeed == 0) {

          while (currentSpeedX != 0) {
            DecelerationMillis = micros();


            if (currentSpeedX > 0) {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedxINT)
              {

                currentSpeedX--;
                DecelerationMillisPREV = micros();
              }
            }
            else {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedxINT)
              {

                currentSpeedX++;
                DecelerationMillisPREV = micros();
              }
            }
            AccelStepperX.setSpeed(currentSpeedX);
            AccelStepperX.runSpeed();

          }


          runX = 0;
          currentSpeedX = 0;

          AccelStepperX.setSpeed(speedX);

          myString = String(AccelStepperX.currentPosition());
          StringSend = "#curPosX_" + myString + "$";
          Serial5.print(StringSend);
          Serial.print("currentKeyframeSettingX:");
          Serial.println(currentKeyframeSettingX);
          if (currentKeyframeSettingX == 1) {
            limitStepsXoffset = limitStepsXoffset + AccelStepperX.currentPosition();

            Serial.print("limitStepsXoffset");
            Serial.println(limitStepsXoffset);
            AccelStepperX.setCurrentPosition(0);
          }


        }
        else {
          currentSpeedX = currentManualSpeed;
          lastSpeedX02 = currentManualSpeed;
          runX = 2;
        }
      }
      break;

    case 1011:
      if (switchreached == true) {
        currentManualSpeed = 0;
        switchreached = false;
      }
      else if ((millis() - reachedtime) > 500) {
        currentManualSpeed = BTvalue.toInt();

        if (currentManualSpeed == 0) {

          while (currentSpeedY != 0) {
            DecelerationMillis = micros();


            if (currentSpeedY > 0) {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedyINT)
              {

                currentSpeedY--;
                DecelerationMillisPREV = micros();
              }
            }
            else {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedyINT)
              {

                currentSpeedY++;
                DecelerationMillisPREV = micros();
              }
            }
            AccelStepperY.setSpeed(currentSpeedY);
            AccelStepperY.runSpeed();

          }


          runY = 0;
          currentSpeedY = 0;

          AccelStepperY.setSpeed(speedY);

          myString = String(AccelStepperY.currentPosition());
          StringSend = "#curPosY_" + myString + "$";
          Serial5.print(StringSend);
          Serial.print("currentKeyframeSettingY:");
          Serial.println(currentKeyframeSettingY);
          if (currentKeyframeSettingY == 1) {
            limitStepsYoffset = limitStepsYoffset + AccelStepperY.currentPosition();

            Serial.print("limitStepsYoffset");
            Serial.println(limitStepsYoffset);
            AccelStepperY.setCurrentPosition(0);
          }


        }
        else {
          currentSpeedY = currentManualSpeed;
          lastSpeedY02 = currentManualSpeed;
          runY = 2;
        }
      }
      break;

    case 1012:
      if (switchreached == true) {
        currentManualSpeed = 0;
        switchreached = false;
      }
      else if ((millis() - reachedtime) > 500) {
        currentManualSpeed = BTvalue.toInt();

        if (currentManualSpeed == 0) {

          while (currentSpeedZ != 0) {
            DecelerationMillis = micros();


            if (currentSpeedZ > 0) {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedzINT)
              {

                currentSpeedZ--;
                DecelerationMillisPREV = micros();
              }
            }
            else {
              if ((DecelerationMillis - DecelerationMillisPREV) >= decelerationSpeedzINT)
              {

                currentSpeedZ++;
                DecelerationMillisPREV = micros();
              }
            }
            AccelStepperZ.setSpeed(currentSpeedZ);
            AccelStepperZ.runSpeed();

          }


          runZ = 0;
          currentSpeedZ = 0;

          AccelStepperZ.setSpeed(speedZ);

          myString = String(AccelStepperZ.currentPosition());
          StringSend = "#curPosZ_" + myString + "$";
          Serial5.print(StringSend);
          Serial.print("currentKeyframeSettingZ:");
          Serial.println(currentKeyframeSettingZ);
          if (currentKeyframeSettingZ == 1) {
            limitStepsZoffset = limitStepsZoffset + AccelStepperZ.currentPosition();

            Serial.print("limitStepsZoffset");
            Serial.println(limitStepsZoffset);
            AccelStepperZ.setCurrentPosition(0);
          }


        }
        else {
          currentSpeedZ = currentManualSpeed;
          lastSpeedZ02 = currentManualSpeed;
          runZ = 2;
        }
      }
      break;

    case 1020:
      u20[0] = u20[0] - AccelStepperU.currentPosition();
      u20[1] = 0;
      u20[2] = u20[2] - AccelStepperU.currentPosition();
      u20[3] = u20[3] - AccelStepperU.currentPosition();
      u20[4] = u20[4] - AccelStepperU.currentPosition();
      u20[5] = u20[5] - AccelStepperU.currentPosition();
      u20[6] = u20[6] - AccelStepperU.currentPosition();

      v20[0] = v20[0] - AccelStepperV.currentPosition();
      v20[1] = 0;
      v20[2] = v20[2] - AccelStepperV.currentPosition();
      v20[3] = v20[3] - AccelStepperV.currentPosition();
      v20[4] = v20[4] - AccelStepperV.currentPosition();
      v20[5] = v20[5] - AccelStepperV.currentPosition();
      v20[6] = v20[6] - AccelStepperV.currentPosition();

      w20[0] = w20[0] - AccelStepperW.currentPosition();
      w20[1] = 0;
      w20[2] = w20[2] - AccelStepperW.currentPosition();
      w20[3] = w20[3] - AccelStepperW.currentPosition();
      w20[4] = w20[4] - AccelStepperW.currentPosition();
      w20[5] = w20[5] - AccelStepperW.currentPosition();
      w20[6] = w20[6] - AccelStepperW.currentPosition();

      x20[0] = x20[0] - AccelStepperX.currentPosition();
      x20[1] = 0;
      x20[2] = x20[2] - AccelStepperX.currentPosition();
      x20[3] = x20[3] - AccelStepperX.currentPosition();
      x20[4] = x20[4] - AccelStepperX.currentPosition();
      x20[5] = x20[5] - AccelStepperX.currentPosition();
      x20[6] = x20[6] - AccelStepperX.currentPosition();

      y20[0] = y20[0] - AccelStepperY.currentPosition();
      y20[1] = 0;
      y20[2] = y20[2] - AccelStepperY.currentPosition();
      y20[3] = y20[3] - AccelStepperY.currentPosition();
      y20[4] = y20[4] - AccelStepperY.currentPosition();
      y20[5] = y20[5] - AccelStepperY.currentPosition();
      y20[6] = y20[6] - AccelStepperY.currentPosition();

      z20[0] = z20[0] - AccelStepperZ.currentPosition();
      z20[1] = 0;
      z20[2] = z20[2] - AccelStepperZ.currentPosition();
      z20[3] = z20[3] - AccelStepperZ.currentPosition();
      z20[4] = z20[4] - AccelStepperZ.currentPosition();
      z20[5] = z20[5] - AccelStepperZ.currentPosition();
      z20[6] = z20[6] - AccelStepperZ.currentPosition();

      AccelStepperU.setCurrentPosition(0);
      AccelStepperV.setCurrentPosition(0);
      AccelStepperW.setCurrentPosition(0);
      AccelStepperX.setCurrentPosition(0);
      AccelStepperY.setCurrentPosition(0);
      AccelStepperZ.setCurrentPosition(0);
      /*
            myString = String(AccelStepperU.currentPosition());
            StringSend = "#curPosU_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperV.currentPosition());
            StringSend = "#curPosV_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperW.currentPosition());
            StringSend = "#curPosW_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperX.currentPosition());
            StringSend = "#curPosX_" + myString + "$";
            Serial5.print(StringSend);

            delay(20);
            myString = String(AccelStepperY.currentPosition());
            StringSend = "#curPosY_" + myString + "$";
            Serial5.print(StringSend);


            delay(20);
            myString = String(AccelStepperZ.currentPosition());
            StringSend = "#curPosZ_" + myString + "$";
            Serial5.print(StringSend);

      */
      break;


    case 1030:
      /*
        P4u = AccelStepperU.currentPosition();
        P4v = AccelStepperV.currentPosition();
        P4w = AccelStepperW.currentPosition();
        P4x = AccelStepperX.currentPosition();
        P4y = AccelStepperY.currentPosition();
        P4z = AccelStepperZ.currentPosition();
      */
      break;

    case 1031:
      /*
        P4u = 0;
        P4v = 0;
        P4w = 0;
        P4x = 0;
        P4y = 0;

        if (BTvalue == "1") {
          P4z = -sliderLength * ZsetupRES;
        }
        else {
          P4z = sliderLength * ZsetupRES;
        }
      */
      break;


    case 1040:
      AccelStepperU.moveTo(0);
      AccelStepperV.moveTo(0);
      AccelStepperW.moveTo(0);
      AccelStepperX.moveTo(0);
      AccelStepperY.moveTo(0);
      AccelStepperZ.moveTo(0);
      movehome = true;
      break;

    case 1050:
      totalPicNo = BTvalue.toInt();
      // Serial.print("totalPicNo:");
      // Serial.println(totalPicNo);
      break;

    case 1051:
      noMoveShots = BTvalue.toInt();
      totalMovePicNo = totalPicNo - 2 * noMoveShots;
      totalMovePicNoFLOAT = (float) totalMovePicNo;
      break;

    case 1060:
      BTvalue.replace(',', '.');
      intervalFloat = 1000 * (BTvalue.toFloat());
      TLinterval = (int) intervalFloat;
      break;

    case 1065:
      TLdelay = BTvalue.toInt();

      //  Serial.print("1065");
      // Serial.println(TLdelay);
      break;

    case 1070:
      returnvalues();
      break;


    case 1085:
      movieLengthSeconds = BTvalue.toInt();
      /*
            if (P4u > 0) {
              speedU = P4u / movieLengthSeconds;
            }
            if (P4v > 0) {
              speedV = P4v / movieLengthSeconds;
            }
            if (P4w > 0) {
              speedW = P4w / movieLengthSeconds;
            }
            if (P4x > 0) {
              speedX = P4x / movieLengthSeconds;
            }
            if (P4y > 0) {
              speedY = P4y / movieLengthSeconds;
            }
            if (P4z > 0) {
              speedZ = P4z / movieLengthSeconds;
            }

            if (P4u < 0) {
              speedU = -(P4u / movieLengthSeconds);
            }
            if (P4v < 0) {
              speedV = -(P4v / movieLengthSeconds);
            }
            if (P4w < 0) {
              speedW = -(P4w / movieLengthSeconds);
            }
            if (P4x < 0) {
              speedX = -(P4x / movieLengthSeconds);
            }
            if (P4y < 0) {
              speedY = -(P4y / movieLengthSeconds);
            }
            if (P4z < 0) {
              speedZ = -(P4z / movieLengthSeconds);
            }

            if (P4u == 0) {
              speedU = 3800;
            }
            if (P4v == 0) {
              speedV = 3800;
            }
            if (P4w == 0) {
              speedW = 3800;
            }
            if (P4x == 0) {
              speedX = 3800;
            }
            if (P4y == 0) {
              speedY = 3800;
            }
            if (P4z == 0) {
              speedZ = 3800;
            }
      */
      break;

    case 1090:

      delayStartSeconds = BTvalue.toInt();



      break;


    case 1101:
      Ustep = BTvalue.toInt();
      break;

    case 1102:
      Vstep = BTvalue.toInt();
      break;

    case 1103:
      Wstep = BTvalue.toInt();
      break;

    case 1104:
      Xstep = BTvalue.toInt();
      break;

    case 1105:
      Ystep = BTvalue.toInt();
      break;

    case 1106:
      Zstep = BTvalue.toInt();
      break;

    case 1107:
      Udir = BTvalue.toInt();
      break;

    case 1108:
      Vdir = BTvalue.toInt();
      break;

    case 1109:
      Wdir = BTvalue.toInt();
      break;

    case 1110:
      Xdir = BTvalue.toInt();
      break;

    case 1111:
      Ydir = BTvalue.toInt();
      break;

    case 1112:
      Zdir = BTvalue.toInt();


      Serial.print(Ustep);
      Serial.print(";");
      Serial.println(Udir);
      Serial.print(Vstep);
      Serial.print(";");
      Serial.println(Vdir);
      Serial.print(Wstep);
      Serial.print(";");
      Serial.println(Wdir);
      Serial.print(Xstep);
      Serial.print(";");
      Serial.println(Xdir);
      Serial.print(Ystep);
      Serial.print(";");
      Serial.println(Ydir);
      Serial.print(Zstep);
      Serial.print(";");
      Serial.println(Zdir);




      AccelStepperX.changePins(Xstep, Xdir);
      AccelStepperY.changePins(Ystep, Ydir);
      AccelStepperZ.changePins(Zstep, Zdir);
      AccelStepperU.changePins(Ustep, Udir);
      AccelStepperV.changePins(Vstep, Vdir);
      AccelStepperW.changePins(Wstep, Wdir);

      AccelStepperU.enableOutputs();
      AccelStepperV.enableOutputs();
      AccelStepperW.enableOutputs();
      AccelStepperX.enableOutputs();
      AccelStepperY.enableOutputs();
      AccelStepperZ.enableOutputs();

      AccelStepperU.setMaxSpeed(speedU);
      AccelStepperV.setMaxSpeed(speedV);
      AccelStepperW.setMaxSpeed(speedW);
      AccelStepperX.setMaxSpeed(speedX);
      AccelStepperY.setMaxSpeed(speedY);
      AccelStepperZ.setMaxSpeed(speedZ);

      //set minimum pulse width to 4 µs
      AccelStepperU.setMinPulseWidth(4);
      AccelStepperV.setMinPulseWidth(4);
      AccelStepperW.setMinPulseWidth(4);
      AccelStepperX.setMinPulseWidth(4);
      AccelStepperY.setMinPulseWidth(4);
      AccelStepperZ.setMinPulseWidth(4);



      break;


    case 1115:
      runinreverse = BTvalue.toInt();

      tempGerundetU = AccelStepperU.currentPosition();
      tempGerundetV = AccelStepperV.currentPosition();
      tempGerundetW = AccelStepperW.currentPosition();
      tempGerundetX = AccelStepperX.currentPosition();
      tempGerundetY = AccelStepperY.currentPosition();
      tempGerundetZ = AccelStepperZ.currentPosition();
      break;

    case 1100:



      PS4disconnect();
      Serial.println("PS4disconnect3");
      shotMode = BTvalue.toInt();

      totalMovePicNo = totalPicNo - 2 * noMoveShots;

      totalMovePicNoFLOAT = (float) totalMovePicNo;





      if (runinreverse == 1) {
        totalPicNoAKTmoveSpline = totalMovePicNoFLOAT + 1;
      }

      tempCurveU.setPoints(n_u20, u20, keyframeAmountU);
      tempCurveU.setDegree(Catmull);

      tempCurveV.setPoints(n_v20, v20, keyframeAmountV);
      tempCurveV.setDegree(Catmull);

      tempCurveW.setPoints(n_w20, w20, keyframeAmountW);
      tempCurveW.setDegree(Catmull);

      tempCurveX.setPoints(n_x20, x20, keyframeAmountX);
      tempCurveX.setDegree(Catmull);

      tempCurveY.setPoints(n_y20, y20, keyframeAmountY);
      tempCurveY.setDegree(Catmull);

      tempCurveZ.setPoints(n_z20, z20, keyframeAmountZ);
      tempCurveZ.setDegree(Catmull);


      TLmaxexpo = TLinterval - 200 - 200 - TLdelay;

      Serial.println("-------------------");
      Serial.print("keyframeAmountX:");
      Serial.println(keyframeAmountX);
      Serial.print("n_x20[0]:");
      Serial.println(n_x20[0]);
      Serial.print("n_x20[1]:");
      Serial.println(n_x20[1]);
      Serial.print("n_x20[2]:");
      Serial.println(n_x20[2]);
      Serial.print("n_x20[3]:");
      Serial.println(n_x20[3]);
      Serial.print("n_x20[4]:");
      Serial.println(n_x20[4]);
      Serial.print("n_x20[5]:");
      Serial.println(n_x20[5]);
      Serial.print("n_x20[6]:");
      Serial.println(n_x20[6]);
      Serial.print("n_x20[7]:");
      Serial.println(n_x20[7]);
      Serial.print("n_x20[8]:");
      Serial.println(n_x20[8]);

      Serial.print("x20[0]:");
      Serial.println(x20[0]);
      Serial.print("x20[1]:");
      Serial.println(x20[1]);
      Serial.print("x20[2]:");
      Serial.println(x20[2]);
      Serial.print("x20[3]:");
      Serial.println(x20[3]);
      Serial.print("x20[4]:");
      Serial.println(x20[4]);
      Serial.print("x20[5]:");
      Serial.println(x20[5]);
      Serial.print("x20[6]:");
      Serial.println(x20[6]);
      Serial.print("x20[7]:");
      Serial.println(x20[7]);
      Serial.print("x20[8]:");
      Serial.println(x20[8]);
      Serial.println("-------------------");
      Serial.print("X-posi:");
      Serial.println(AccelStepperX.currentPosition());


      tempGerundetU = 0;
      tempGerundetV = 0;
      tempGerundetW = 0;
      tempGerundetX = 0;
      tempGerundetY = 0;
      tempGerundetZ = 0;
      startTL = true;

      digitalWrite(dslrFocus, HIGH);
      delay(100);
      digitalWrite(dslrFocus, LOW);
      delay(600);
      break;





      break;

    case 1121:
      motionTypeU = BTvalue.toInt();

      break;

    case 1122:
      motionTypeV = BTvalue.toInt();

      break;

    case 1123:
      motionTypeW = BTvalue.toInt();

      break;

    case 1124:
      motionTypeX = BTvalue.toInt();

      break;

    case 1125:
      motionTypeY = BTvalue.toInt();

      break;

    case 1126:
      motionTypeZ = BTvalue.toInt();

      break;

    case 1901:
      IHOLDu = BTvalue.toInt();
      currentholdU = (float)IHOLDu / (float)31;
      break;
    case 1902:
      IHOLDv = BTvalue.toInt();
      currentholdV = (float)IHOLDv / (float)31;
      break;
    case 1903:
      IHOLDw = BTvalue.toInt();
      currentholdW = (float)IHOLDw / (float)31;
      break;
    case 1904:
      IHOLDx = BTvalue.toInt();
      currentholdX = (float)IHOLDx / (float)31;
      break;
    case 1905:
      IHOLDy = BTvalue.toInt();
      currentholdY = (float)IHOLDy / (float)31;
      break;
    case 1906:
      IHOLDz = BTvalue.toInt();
      currentholdZ = (float)IHOLDz / (float)31;
      break;
    case 1911:
      IRUNu = BTvalue.toInt();
      rmscurrentU = (driverRMScurrent * IRUNu) / 31;
      break;
    case 1912:
      IRUNv = BTvalue.toInt();
      rmscurrentV = (driverRMScurrent * IRUNv) / 31;
      break;
    case 1913:
      IRUNw = BTvalue.toInt();
      rmscurrentW = (driverRMScurrent * IRUNw) / 31;
      break;
    case 1914:
      IRUNx = BTvalue.toInt();
      rmscurrentX = (driverRMScurrent * IRUNx) / 31;
      break;
    case 1915:
      IRUNy = BTvalue.toInt();
      rmscurrentY = (driverRMScurrent * IRUNy) / 31;
      break;
    case 1916:
      IRUNz = BTvalue.toInt();
      rmscurrentZ = (driverRMScurrent * IRUNz) / 31;
      break;

    case 1200:
      //setUresolution(BTvalue.toInt());
      UsetupRES = BTvalue.toInt();

      if (UsetupRES == 1) {
        UsetupRES = 0;
      }

      break;

    case 1210:
      //setVresolution(BTvalue.toInt());
      VsetupRES = BTvalue.toInt();
      if (VsetupRES == 1) {
        VsetupRES = 0;
      }
      break;

    case 1220:
      //setWresolution(BTvalue.toInt());
      WsetupRES = BTvalue.toInt();
      if (WsetupRES == 1) {
        WsetupRES = 0;
      }
      break;

    case 1230:
      //setXresolution(BTvalue.toInt());
      XsetupRES = BTvalue.toInt();
      if (XsetupRES == 1) {
        XsetupRES = 0;
      }
      break;

    case 1240:
      //setYresolution(BTvalue.toInt());
      YsetupRES = BTvalue.toInt();
      if (YsetupRES == 1) {
        YsetupRES = 0;
      }
      break;

    case 1250:
      // setZresolution(BTvalue.toInt());
      ZsetupRES = BTvalue.toInt();
      if (ZsetupRES == 1) {
        ZsetupRES = 0;
      }
      break;

    case 1260:
      if (BTvalue.toInt() == 0) {
        stepperUactive = false;
      }
      else {
        stepperUactive = true;
      }
      break;

    case 1261:
      if (BTvalue.toInt() == 0) {
        stepperVactive = false;
      }
      else {
        stepperVactive = true;
      }
      break;

    case 1262:
      if (BTvalue.toInt() == 0) {
        stepperWactive = false;
      }
      else {
        stepperWactive = true;
      }
      break;

    case 1263:
      if (BTvalue.toInt() == 0) {
        stepperXactive = false;
      }
      else {
        stepperXactive = true;
      }
      break;

    case 1264:
      if (BTvalue.toInt() == 0) {
        stepperYactive = false;
      }
      else {
        stepperYactive = true;
      }
      break;

    case 1265:
      if (BTvalue.toInt() == 0) {
        stepperZactive = false;
      }
      else {
        stepperZactive = true;
      }
      break;


    case 1301:
      stepAmountU = BTvalue.toInt();
      break;
    case 1302:
      stepAmountV = BTvalue.toInt();
      break;
    case 1303:
      stepAmountW = BTvalue.toInt();
      break;
    case 1304:
      stepAmountX = BTvalue.toInt();
      break;
    case 1305:
      stepAmountY = BTvalue.toInt();
      break;
    case 1306:
      stepAmountZ = BTvalue.toInt();
      break;

    case 1311:
      Ubacklash = BTvalue.toInt();
      break;
    case 1312:
      Vbacklash = BTvalue.toInt();
      break;
    case 1313:
      Wbacklash = BTvalue.toInt();
      break;
    case 1314:
      Xbacklash = BTvalue.toInt();
      break;
    case 1315:
      Ybacklash = BTvalue.toInt();
      break;
    case 1316:
      Zbacklash = BTvalue.toInt();
      break;


    case 1401:
      speedU = BTvalue.toInt();
      break;

    case 1402:
      speedV = BTvalue.toInt();
      break;

    case 1403:
      speedW = BTvalue.toInt();
      break;

    case 1404:
      speedX = BTvalue.toInt();
      break;

    case 1405:
      speedY = BTvalue.toInt();
      break;

    case 1406:
      speedZ = BTvalue.toInt();
      setMaxSpeedSteppers();
      break;

    case 1411:
      maxManualSpeedU = BTvalue.toInt();

      break;

    case 1412:
      maxManualSpeedV = BTvalue.toInt();

      break;

    case 1413:
      maxManualSpeedW = BTvalue.toInt();

      break;

    case 1414:
      maxManualSpeedX = BTvalue.toInt();

      break;

    case 1415:
      maxManualSpeedY = BTvalue.toInt();

      break;

    case 1416:
      maxManualSpeedZ = BTvalue.toInt();

      break;



    case 1431:
      if (BTvalue.toInt() == 1) {
        AccelStepperU.setPinsInverted(true, false, true);
      }
      else {
        AccelStepperU.setPinsInverted(false, false, true);
      }
      break;

    case 1432:
      if (BTvalue.toInt() == 1) {
        AccelStepperV.setPinsInverted(true, false, true);
      }
      else {
        AccelStepperV.setPinsInverted(false, false, true);
      }
      break;

    case 1433:
      if (BTvalue.toInt() == 1) {
        AccelStepperW.setPinsInverted(true, false, true);
      }
      else {
        AccelStepperW.setPinsInverted(false, false, true);
      }
      break;

    case 1434:
      if (BTvalue.toInt() == 1) {
        AccelStepperX.setPinsInverted(true, false, true);
      }
      else {
        AccelStepperX.setPinsInverted(false, false, true);
      }
      break;

    case 1435:
      if (BTvalue.toInt() == 1) {
        AccelStepperY.setPinsInverted(true, false, true);
      }
      else {
        AccelStepperY.setPinsInverted(false, false, true);
      }
      break;

    case 1436:
      if (BTvalue.toInt() == 1) {
        AccelStepperZ.setPinsInverted(true, false, true);
      }
      else {
        AccelStepperZ.setPinsInverted(false, false, true);
      }
      break;

    case 1441:

      manualAccelU = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeeduDouble = (manualAccelU * 1000 / maxManualSpeedU) + 0.5 ;
      decelerationSpeeduINT = (int)decelerationSpeeduDouble;
      break;

    case 1442:

      manualAccelV = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedvDouble = (manualAccelV * 1000 / maxManualSpeedV) + 0.5 ;
      decelerationSpeedvINT = (int)decelerationSpeedvDouble;
      break;

    case 1443:

      manualAccelW = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedwDouble = (manualAccelW * 1000 / maxManualSpeedW) + 0.5 ;
      decelerationSpeedwINT = (int)decelerationSpeedwDouble;
      break;

    case 1444:


      manualAccelX = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedxDouble = (manualAccelX * 1000 / maxManualSpeedX) + 0.5 ;
      decelerationSpeedxINT = (int)decelerationSpeedxDouble;

      break;

    case 1445:

      manualAccelY = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedyDouble = (manualAccelY * 1000 / maxManualSpeedY) + 0.5 ;
      decelerationSpeedyINT = (int)decelerationSpeedyDouble;
      break;

    case 1446:

      manualAccelZ = BTvalue.toInt();
      //acceleration and deceleration for manual move in µs
      decelerationSpeedzDouble = (manualAccelZ * 1000 / maxManualSpeedZ) + 0.5 ;
      decelerationSpeedzINT = (int)decelerationSpeedzDouble;

      decelerationSpeedManual_uINT = decelerationSpeeduINT;
      decelerationSpeedManual_vINT = decelerationSpeedvINT;
      decelerationSpeedManual_wINT = decelerationSpeedwINT;
      decelerationSpeedManual_xINT = decelerationSpeedxINT;
      decelerationSpeedManual_yINT = decelerationSpeedyINT;
      decelerationSpeedManual_zINT = decelerationSpeedzINT;
      decelerationSpeedManualALL = 999;
      break;

    case 1447:
      decelerationSpeedManualALL = BTvalue.toInt();

      if (decelerationSpeedManualALL == 999) {
        decelerationSpeedManual_uINT = decelerationSpeeduINT;
        decelerationSpeedManual_vINT = decelerationSpeedvINT;
        decelerationSpeedManual_wINT = decelerationSpeedwINT;
        decelerationSpeedManual_xINT = decelerationSpeedxINT;
        decelerationSpeedManual_yINT = decelerationSpeedyINT;
        decelerationSpeedManual_zINT = decelerationSpeedzINT;

      }
      else {
        //acceleration and deceleration for manual move in µs
        decelerationSpeeduDouble = (decelerationSpeedManualALL * 1000 / constantSpeedUprev) + 0.5 ;
        decelerationSpeedvDouble = (decelerationSpeedManualALL * 1000 / constantSpeedVprev) + 0.5 ;
        decelerationSpeedwDouble = (decelerationSpeedManualALL * 1000 / constantSpeedWprev) + 0.5 ;
        decelerationSpeedxDouble = (decelerationSpeedManualALL * 1000 / constantSpeedXprev) + 0.5 ;
        decelerationSpeedyDouble = (decelerationSpeedManualALL * 1000 / constantSpeedYprev) + 0.5 ;
        decelerationSpeedzDouble = (decelerationSpeedManualALL * 1000 / constantSpeedZprev) + 0.5 ;

        decelerationSpeedManual_uINT = (int)decelerationSpeeduDouble;
        decelerationSpeedManual_vINT = (int)decelerationSpeedvDouble;
        decelerationSpeedManual_wINT = (int)decelerationSpeedwDouble;
        decelerationSpeedManual_xINT = (int)decelerationSpeedxDouble;
        decelerationSpeedManual_yINT = (int)decelerationSpeedyDouble;
        decelerationSpeedManual_zINT = (int)decelerationSpeedzDouble;
      }

      break;

    case  1448:

      AccelStepperU.setCurrentPosition(0);
      AccelStepperV.setCurrentPosition(0);
      AccelStepperW.setCurrentPosition(0);
      AccelStepperX.setCurrentPosition(0);
      AccelStepperY.setCurrentPosition(0);
      AccelStepperZ.setCurrentPosition(0);

      AccelStepperU.moveTo(0);
      AccelStepperV.moveTo(0);
      AccelStepperW.moveTo(0);
      AccelStepperX.moveTo(0);
      AccelStepperY.moveTo(0);
      AccelStepperZ.moveTo(0);

      break;

    case 1451:
      accelerationAmountU = BTvalue.toInt() * 100;
      break;

    case 1452:
      accelerationAmountV = BTvalue.toInt() * 100;
      break;

    case 1453:
      accelerationAmountW = BTvalue.toInt() * 100;
      break;

    case 1454:
      accelerationAmountX = BTvalue.toInt() * 100;
      break;

    case 1455:
      accelerationAmountY = BTvalue.toInt() * 100;
      break;

    case 1456:
      accelerationAmountZ = BTvalue.toInt() * 100;
      break;


    case 1500:
      slaveTouchbuttonClick = 1;
      break;

    case 1600:
      panoRows = BTvalue.toInt();
      break;

    case 1601:
      panoColumns = BTvalue.toInt();
      panoTotalPicAmount = panoRows * panoColumns;
      break;

    case 1610:
      PS4disconnect();
      Serial.println("PS4disconnect4");
      BTvalue.replace(',', '.');
      MaxExpoFloat = 1000 * (BTvalue.toFloat());
      TLmaxexpo = 500 + (int) MaxExpoFloat;
      // Serial.print("MaxExpoFloat:");
      //Serial.println(MaxExpoFloat);
      // Serial.print("TLmaxexpo:");
      // Serial.println(TLmaxexpo);

      startPano = true;

      panoMode = "horizontal";
      panoCurrentPic = 0;
      currentRow = 1;
      currentColumn = 1;
      digitalWrite(dslrFocus, HIGH);
      delay(100);
      digitalWrite(dslrFocus, LOW);
      delay(600);
      break;

    case 1611:
      PS4disconnect();
      Serial.println("PS4disconnect5");
      BTvalue.replace(',', '.');
      MaxExpoFloat = 1000 * (BTvalue.toFloat());
      TLmaxexpo = 500 + (int) MaxExpoFloat;
      // Serial.print("1611:");
      // Serial.println(TLmaxexpo);

      startPanoVertical = true;

      panoMode = "vertical";
      panoCurrentPic = 0;
      currentRow = 1;
      currentColumn = 1;
      digitalWrite(dslrFocus, HIGH);
      delay(100);
      digitalWrite(dslrFocus, LOW);
      delay(600);
      break;

    case 1615:
      PanoHorizontalMoveSteps = BTvalue.toInt();

      break;

    case 1616:
      PanoVerticalMoveSteps = BTvalue.toInt();

      break;

    case 1700:

      digitalWrite(dslrFocus, HIGH);
      digitalWrite(dslrTrigger, HIGH);
      delay(200);
      digitalWrite(dslrTrigger, LOW);
      digitalWrite(dslrFocus, LOW);
      break;

    case 1800:
      voltageCam = analogRead(voltageReadCam);
      myString = String(voltageCam);
      StringSend = "#voltageCam_" + myString + "$";
      Serial5.print(StringSend);

      break;



    case 1801:

      currentKeyframe = BTvalue.toInt();

      switch (currentKeyframe) {
        case 0:


          AccelStepperU.moveTo(0);
          AccelStepperV.moveTo(0);
          AccelStepperW.moveTo(0);
          AccelStepperX.moveTo(0);
          AccelStepperY.moveTo(0);
          AccelStepperZ.moveTo(0);
          if (keyframeMovement == true) {
            moveKeyframe = true;
          }
          break;

        case 1:

          if (keyframe1new == true) {
            if (keyframeMovement == true) {
              keyframe1new = false;



            }
          }
          else {


            AccelStepperU.moveTo(u20[2]);
            AccelStepperV.moveTo(v20[2]);
            AccelStepperW.moveTo(w20[2]);
            AccelStepperX.moveTo(x20[2]);
            AccelStepperY.moveTo(y20[2]);
            AccelStepperZ.moveTo(z20[2]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
        case 2:

          if (keyframe2new == true) {
            if (keyframeMovement == true) {
              keyframe2new = false;



            }
          }
          else {


            AccelStepperU.moveTo(u20[3]);
            AccelStepperV.moveTo(v20[3]);
            AccelStepperW.moveTo(w20[3]);
            AccelStepperX.moveTo(x20[3]);
            AccelStepperY.moveTo(y20[3]);
            AccelStepperZ.moveTo(z20[3]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
        case 3:

          if (keyframe3new == true) {
            if (keyframeMovement == true) {
              keyframe3new = false;
            }
          }
          else {


            AccelStepperU.moveTo(u20[4]);
            AccelStepperV.moveTo(v20[4]);
            AccelStepperW.moveTo(w20[4]);
            AccelStepperX.moveTo(x20[4]);
            AccelStepperY.moveTo(y20[4]);
            AccelStepperZ.moveTo(z20[4]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
        case 4:

          if (keyframeEndnew == true) {
            // Serial.println("1111");
            if (keyframeMovement == true) {
              //   Serial.println("2222");
              keyframeEndnew = false;
            }
          }
          else {

            //  Serial.print("pos4:");
            // Serial.println(u20[5]);
            AccelStepperU.moveTo(u20[5]);
            AccelStepperV.moveTo(v20[5]);
            AccelStepperW.moveTo(w20[5]);
            AccelStepperX.moveTo(x20[5]);
            AccelStepperY.moveTo(y20[5]);
            AccelStepperZ.moveTo(z20[5]);
            if (keyframeMovement == true) {
              moveKeyframe = true;
            }
          }
          break;
      }



      break;


    case 1899:
      resetKeyframes = false;
      break;
    case 1900:
      videoPointUpdateTime = BTvalue.toInt();

      break;

    case 2000:
      PS4disconnect();
      Serial.println("PS4disconnect6");
      millisforcalcPREV = millis();
      setVideoData();
      transmitValues();


      break;


    case 3000:
      myString = String(versionNo);
      StringSend = "#versionNo_" + myString + "$";
      Serial5.print(StringSend);
      break;

    case 3010:
      myString = String(totalPicNo);
      StringSend = "#totalPicNo_" + myString + "$";
      Serial5.print(StringSend);
      break;

    case 3020:
      myString = String(TLinterval);
      StringSend = "#interval_" + myString + "$";
      Serial5.print(StringSend);
      break;

    case 3030:
      resetValues();
      break;

    //-----Preset-Transmit-----
    case 4010:
      u20[0] = BTvalue.toInt();
      u20[2] = BTvalue.toInt();
      break;

    case 4011:
      u20[3] = BTvalue.toInt();
      break;

    case 4012:
      u20[4] = BTvalue.toInt();
      u20[6] = BTvalue.toInt();
      break;

    case 4013:
      u20[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4020:
      v20[0] = BTvalue.toInt();
      v20[2] = BTvalue.toInt();
      break;

    case 4021:
      v20[3] = BTvalue.toInt();
      break;

    case 4022:
      v20[4] = BTvalue.toInt();
      v20[6] = BTvalue.toInt();
      break;

    case 4023:
      v20[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4030:
      w20[0] = BTvalue.toInt();
      w20[2] = BTvalue.toInt();
      break;

    case 4031:
      w20[3] = BTvalue.toInt();
      break;

    case 4032:
      w20[4] = BTvalue.toInt();
      w20[6] = BTvalue.toInt();
      break;

    case 4033:
      w20[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4040:
      x20[0] = BTvalue.toInt();
      x20[2] = BTvalue.toInt();
      break;

    case 4041:
      x20[3] = BTvalue.toInt();
      break;

    case 4042:
      x20[4] = BTvalue.toInt();
      x20[6] = BTvalue.toInt();
      break;

    case 4043:
      x20[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4050:
      y20[0] = BTvalue.toInt();
      y20[2] = BTvalue.toInt();
      break;

    case 4051:
      y20[3] = BTvalue.toInt();
      break;

    case 4052:
      y20[4] = BTvalue.toInt();
      y20[6] = BTvalue.toInt();
      break;

    case 4053:
      y20[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 4060:
      z20[0] = BTvalue.toInt();
      z20[2] = BTvalue.toInt();
      break;

    case 4061:
      z20[3] = BTvalue.toInt();
      break;

    case 4062:
      z20[4] = BTvalue.toInt();
      z20[6] = BTvalue.toInt();
      break;

    case 4063:
      z20[5] = BTvalue.toInt();
      keyframeStartnew = false;
      keyframe1new = false;
      keyframe2new = false;
      keyframe3new = false;
      keyframeEndnew = false;
      break;

    case 5001:
      AccelStepperU.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());

      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          u20[0] = BTvalue.toInt();
          u20[2] = BTvalue.toInt();
          break;

        case 2:
          u20[3] = BTvalue.toInt();
          break;

        case 3:
          u20[4] = BTvalue.toInt();
          u20[6] = BTvalue.toInt();
          break;

        case 4:
          u20[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      } else {
        myString = String(BTvalue.toInt());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5002:
      AccelStepperV.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          v20[0] = BTvalue.toInt();
          v20[2] = BTvalue.toInt();
          break;

        case 2:
          v20[3] = BTvalue.toInt();
          break;

        case 3:
          v20[4] = BTvalue.toInt();
          v20[6] = BTvalue.toInt();
          break;

        case 4:
          v20[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5003:
      AccelStepperW.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          w20[0] = BTvalue.toInt();
          w20[2] = BTvalue.toInt();
          break;

        case 2:
          w20[3] = BTvalue.toInt();
          break;

        case 3:
          w20[4] = BTvalue.toInt();
          w20[6] = BTvalue.toInt();
          break;

        case 4:
          w20[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5004:
      AccelStepperX.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          x20[0] = BTvalue.toInt();
          x20[2] = BTvalue.toInt();
          break;

        case 2:
          x20[3] = BTvalue.toInt();
          break;

        case 3:
          x20[4] = BTvalue.toInt();
          x20[6] = BTvalue.toInt();
          break;

        case 4:
          x20[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5005:
      AccelStepperY.moveTo(BTvalue.toInt());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperZ.moveTo(AccelStepperZ.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          y20[0] = BTvalue.toInt();
          y20[2] = BTvalue.toInt();
          break;

        case 2:
          y20[3] = BTvalue.toInt();
          break;

        case 3:
          y20[4] = BTvalue.toInt();
          y20[6] = BTvalue.toInt();
          break;

        case 4:
          y20[5] = BTvalue.toInt();
          break;

      }
      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5006:
      AccelStepperZ.moveTo(BTvalue.toInt());
      AccelStepperY.moveTo(AccelStepperY.currentPosition());
      AccelStepperX.moveTo(AccelStepperX.currentPosition());
      AccelStepperU.moveTo(AccelStepperU.currentPosition());
      AccelStepperV.moveTo(AccelStepperV.currentPosition());
      AccelStepperW.moveTo(AccelStepperW.currentPosition());
      switch (currentKeyframe) {
        case 0:
          break;

        case 1:
          z20[0] = BTvalue.toInt();
          z20[2] = BTvalue.toInt();
          break;

        case 2:
          z20[3] = BTvalue.toInt();
          break;

        case 3:
          z20[4] = BTvalue.toInt();
          z20[6] = BTvalue.toInt();
          break;

        case 4:
          z20[5] = BTvalue.toInt();
          break;

      }

      if (keyframeMovement == true) {
        moveKeyframe = true;
      }
      else {
        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(BTvalue.toInt());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = "0";
        StringSend = "#keyframeReached_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;

    case 5100:

      panoPause = BTvalue.toInt();
      if (panoPause == 0) {
        pausePano = true;
      }
      else if (panoPause == 1) {
        digitalWrite(dslrFocus, HIGH);
        delay(100);
        digitalWrite(dslrFocus, LOW);
        delay(600);
        pausePano = false;
        startPano = true;
        //  Serial.println("panoPausefalse");
        previousMillis = millis();
      }
      else {
        digitalWrite(dslrFocus, HIGH);
        delay(100);
        digitalWrite(dslrFocus, LOW);
        delay(600);
        pausePano = false;
        startPanoVertical = true;
        //  Serial.println("panoPausefalse");
        previousMillis = millis();
      }

      break;

    case 5101:

      tlPause = BTvalue.toInt();


      if (tlPause == 1) {
        pauseTL = true;
      } else {
        digitalWrite(dslrFocus, HIGH);
        delay(100);
        digitalWrite(dslrFocus, LOW);
        delay(600);
        pauseTL = false;
        previousMillis = millis();
      }

      break;


    case 5200:
      if (PS4.connected()) {
        if (BTvalue.toInt() == 1 && PS4.getBatteryLevel() < 5) {
          myString = String(PS4.getBatteryLevel());
          StringSend = "#ps4bat_" + myString + "$";
          Serial5.print(StringSend);
        }
      }

      if (BTvalue.toInt() == 0) {
        myString = String(PS4.getBatteryLevel());
        StringSend = "#ps4bat_" + myString + "$";
        Serial5.print(StringSend);
      }

      break;

    case 5300:




      if (BTvalue.toInt() == 1) {
        //    Serial.println("Backlash-Prozess START");
        backlashprocess();
        //   Serial.println("Backlash-Prozess END");
        startAstro = true;
      }
      else {


        startAstro = false;
      }
      break;
    case 5301:
      AstroPicRepete = BTvalue.toInt();
      break;
    case 5302:
      AstroExpoTime01 = BTvalue.toInt();
      break;
    case 5303:
      AstroExpoTime02 = BTvalue.toInt();
      break;
    case 5304:
      AstroExpoTime03 = BTvalue.toInt();
      break;
    case 5305:
      AstroExpo01delay = BTvalue.toInt();
      break;
    case 5306:
      AstroExpo02delay = BTvalue.toInt();
      break;
    case 5307:
      AstroExpo03delay = BTvalue.toInt();
      break;

    case 5310:
      astroPicActive = true;
      //Serial.println("halli");

      break;
    case 5320:
      AstroObject = BTvalue.toInt();
      break;


    case 6000:
      if (BTvalue.toInt() == 0) {
        keyframeMovement = false;
      }
      else {
        keyframeMovement = true;
      }

      break;

    case 7000:


      //getcurrentpositions
      myString = String((long)u20[5]);
      StringSend = "#curPosU_" + myString + "$";
      Serial5.print(StringSend);
      //  Serial.println(StringSend);
      delay(30);
      myString = String((long)v20[5]);
      StringSend = "#curPosV_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)w20[5]);
      StringSend = "#curPosW_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)x20[5]);
      StringSend = "#curPosX_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)y20[5]);
      StringSend = "#curPosY_" + myString + "$";
      Serial5.print(StringSend);
      // Serial.println(StringSend);
      delay(30);
      myString = String((long)z20[5]);
      StringSend = "#curPosZ_" + myString + "$";
      Serial5.print(StringSend);
      //Serial.println(StringSend);
      delay(30);
      break;



    case 7981:
      totalKeyframeAmountU  = BTvalue.toFloat();
      break;
    case 7982:
      totalKeyframeAmountV  = BTvalue.toFloat();
      break;
    case 7983:
      totalKeyframeAmountW  = BTvalue.toFloat();
      break;
    case 7984:
      totalKeyframeAmountX  = BTvalue.toFloat();
      break;
    case 7985:
      totalKeyframeAmountY  = BTvalue.toFloat();
      break;
    case 7986:
      totalKeyframeAmountZ  = BTvalue.toFloat();
      break;


    case 7991:
      currentKeyframeSettingU = BTvalue.toInt();
    case 7992:
      currentKeyframeSettingV = BTvalue.toInt();
    case 7993:
      currentKeyframeSettingW = BTvalue.toInt();
    case 7994:
      currentKeyframeSettingX = BTvalue.toInt();
    case 7995:
      currentKeyframeSettingY = BTvalue.toInt();
    case 7996:
      currentKeyframeSettingZ = BTvalue.toInt();
      break;

    //-------Receive Keyframes------------
    case 8000:
      selectedmode = BTvalue.toInt();
      Serial.print("selectedmode:");
      Serial.println(selectedmode);

      break;

    //--------U-axis--------
    case 8010:
      currentKeyframeU = BTvalue.toInt();
      if (currentKeyframeU <= keyframeAmountU) {
        keyframeAmountU = currentKeyframeU + 1;
      }
      break;

    case 8011:
      if (selectedmode == 0) {
        n_u20[currentKeyframeU] = (totalMovePicNoFLOAT - 1) * BTvalue.toFloat();
      }
      else {
        n_u20[currentKeyframeU] = splinepointamount * BTvalue.toFloat();
      }

      break;

    case 8012:
      u20[currentKeyframeU] = BTvalue.toFloat();
      break;
    //--------V-axis--------
    case 8020:
      currentKeyframeV = BTvalue.toInt();
      if (currentKeyframeV <= keyframeAmountV) {
        keyframeAmountV = currentKeyframeV + 1;
      }

      break;

    case 8021:
      if (selectedmode == 0) {
        n_v20[currentKeyframeV] = (totalMovePicNoFLOAT - 1) * BTvalue.toFloat();
      }
      else {
        n_v20[currentKeyframeV] = splinepointamount * BTvalue.toFloat();
      }
      break;

    case 8022:
      v20[currentKeyframeV] = BTvalue.toFloat();
      break;
    //--------W-axis--------
    case 8030:
      currentKeyframeW = BTvalue.toInt();
      if (currentKeyframeW <= keyframeAmountW) {
        keyframeAmountW = currentKeyframeW + 1;
      }
      break;

    case 8031:
      if (selectedmode == 0) {
        n_w20[currentKeyframeW] = (totalMovePicNoFLOAT - 1) * BTvalue.toFloat();
      }
      else {
        n_w20[currentKeyframeW] = splinepointamount * BTvalue.toFloat();
      }
      break;

    case 8032:
      w20[currentKeyframeW] = BTvalue.toFloat();
      break;
    //--------X-axis--------
    case 8040:
      currentKeyframeX = BTvalue.toInt();
      if (currentKeyframeX <= keyframeAmountX) {
        keyframeAmountX = currentKeyframeX + 1;
      }
      break;

    case 8041:
      if (selectedmode == 0) {
        n_x20[currentKeyframeX] = (totalMovePicNoFLOAT - 1) * BTvalue.toFloat();
      }
      else {
        n_x20[currentKeyframeX] = splinepointamount * BTvalue.toFloat();
      }
      break;

    case 8042:
      x20[currentKeyframeX] = BTvalue.toFloat();
      break;
    //--------Y-axis--------
    case 8050:
      currentKeyframeY = BTvalue.toInt();
      if (currentKeyframeY <= keyframeAmountY) {
        keyframeAmountY = currentKeyframeY + 1;
      }
      break;

    case 8051:
      Serial.println("8051---");
      if (selectedmode == 0) {
        n_y20[currentKeyframeY] = (totalMovePicNoFLOAT - 1) * BTvalue.toFloat();
        Serial.print("totalMovePicNoFLOAT2222:");
        Serial.println(totalMovePicNoFLOAT);
      }
      else {
        n_y20[currentKeyframeY] = splinepointamount * BTvalue.toFloat();
      }
      break;

    case 8052:
      y20[currentKeyframeY] = BTvalue.toFloat();
      break;
    //--------Z-axis--------
    case 8060:
      currentKeyframeZ = BTvalue.toInt();
      if (currentKeyframeZ <= keyframeAmountZ) {
        keyframeAmountZ = currentKeyframeZ + 1;
      }
      break;

    case 8061:
      if (selectedmode == 0) {
        n_z20[currentKeyframeZ] = (totalMovePicNoFLOAT - 1) * BTvalue.toFloat();
      }
      else {
        n_z20[currentKeyframeZ] = splinepointamount * BTvalue.toFloat();
      }
      break;

    case 8062:
      z20[currentKeyframeZ] = BTvalue.toFloat();
      Serial.print("totalKeyframeAmountZ:");
      Serial.println(totalKeyframeAmountZ);
      Serial.print("keyframeAmountZ:");
      Serial.println(keyframeAmountZ);

      if (totalKeyframeAmountZ == keyframeAmountZ) {

        StringSend = "#transmitFinished_0$";
        Serial5.print(StringSend);
        Serial.println("transmitFinished");
      }
      break;


    case 8100:
      //idlecurrentwakeup();
      previousMillisVidArray = micros();
      currentMillisVidArray = micros();
      vidStartMicros = micros();
      startMovie = true;
      MovieReversed = false;
      posii = 0;
      break;

    case 8101:
      //idlecurrentwakeup();
      previousMillisVidArray = micros();
      currentMillisVidArray = micros();
      vidStartMicros = micros();
      startMovie = true;
      MovieReversed = true;
      posii = splinepointamount;
      break;
    case 8105:

      VideoDuration = BTvalue.toFloat();

      break;

    case 9001:
      stepAmountU = BTvalue.toInt();

      break;
    case 9002:
      stepAmountV = BTvalue.toInt();

      break;
    case 9003:
      stepAmountW = BTvalue.toInt();

      break;
    case 9004:
      stepAmountX = BTvalue.toInt();

      break;
    case 9005:
      stepAmountY = BTvalue.toInt();

      break;
    case 9006:
      stepAmountZ = BTvalue.toInt();


      if (keyframeMovement == true) {
        moveKeyframe = true;
        AccelStepperU.setCurrentPosition(AccelStepperU.currentPosition());
        AccelStepperV.setCurrentPosition(AccelStepperV.currentPosition());
        AccelStepperW.setCurrentPosition(AccelStepperW.currentPosition());
        AccelStepperX.setCurrentPosition(AccelStepperX.currentPosition());
        AccelStepperY.setCurrentPosition(AccelStepperY.currentPosition());
        AccelStepperZ.setCurrentPosition(AccelStepperZ.currentPosition());
      }
      else {
        AccelStepperU.setCurrentPosition(stepAmountU);
        AccelStepperV.setCurrentPosition(stepAmountV);
        AccelStepperW.setCurrentPosition(stepAmountW);
        AccelStepperX.setCurrentPosition(stepAmountX);
        AccelStepperY.setCurrentPosition(stepAmountY);
        AccelStepperZ.setCurrentPosition(stepAmountZ);

        myString = String(AccelStepperU.currentPosition());
        StringSend = "#curPosU_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperV.currentPosition());
        StringSend = "#curPosV_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperW.currentPosition());
        StringSend = "#curPosW_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperX.currentPosition());
        StringSend = "#curPosX_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperY.currentPosition());
        StringSend = "#curPosY_" + myString + "$";
        Serial5.print(StringSend);

        delay(40);
        myString = String(AccelStepperZ.currentPosition());
        StringSend = "#curPosZ_" + myString + "$";
        Serial5.print(StringSend);



      }
      break;
    //-----------LIMIT U-axis-----------
    case 2201:
      limitenabled = BTvalue.toInt();
      if (limitenabled == 0) {
        limitEnabledU = false;
      }
      else {
        limitEnabledU = true;
      }
      break;

    case 2211:
      limitStepsU = BTvalue.toInt();
      break;

    case 2221:
      limitSwitchPinU = BTvalue.toInt();
      pinMode(limitSwitchPinU, INPUT_PULLDOWN);
      break;

    case 2231:
      limitBackOffU = BTvalue.toInt();
      break;

    case 2241:
      autoenabled = BTvalue.toInt();


      if (autoenabled == 0) {
        autoRefRunU = false;
      }
      else {
        autoRefRunU = true;
      }
      break;
    //-----------LIMIT V-axis-----------
    case 2202:
      limitenabled = BTvalue.toInt();
      if (limitenabled == 0) {
        limitEnabledV = false;
      }
      else {
        limitEnabledV = true;
      }
      break;
    case 2212:
      limitStepsV = BTvalue.toInt();
      break;

    case 2222:
      limitSwitchPinV = BTvalue.toInt();
      pinMode(limitSwitchPinV, INPUT_PULLDOWN);
      break;

    case 2232:
      limitBackOffV = BTvalue.toInt();
      break;

    case 2242:
      autoenabled = BTvalue.toInt();
      if (autoenabled == 0) {
        autoRefRunV = false;
      }
      else {
        autoRefRunV = true;
      }
      break;
    //-----------LIMIT W-axis-----------
    case 2203:
      limitenabled = BTvalue.toInt();
      if (limitenabled == 0) {
        limitEnabledW = false;
      }
      else {
        limitEnabledW = true;
      }
      break;
    case 2213:
      limitStepsW = BTvalue.toInt();
      break;

    case 2223:
      limitSwitchPinW = BTvalue.toInt();
      pinMode(limitSwitchPinW, INPUT_PULLDOWN);
      break;

    case 2233:
      limitBackOffW = BTvalue.toInt();
      break;

    case 2243:
      autoenabled = BTvalue.toInt();
      if (autoenabled == 0) {
        autoRefRunW = false;
      }
      else {
        autoRefRunW = true;
      }
      break;
    //-----------LIMIT X-axis-----------
    case 2204:
      limitenabled = BTvalue.toInt();
      Serial.print("limitenabledXXX:");
      Serial.println(limitenabled);
      if (limitenabled == 0) {
        limitEnabledX = false;
      }
      else {
        limitEnabledX = true;
      }
      break;
    case 2214:
      limitStepsX = BTvalue.toInt();
      break;

    case 2224:
      limitSwitchPinX = BTvalue.toInt();
      pinMode(limitSwitchPinX, INPUT_PULLDOWN);
      break;

    case 2234:
      limitBackOffX = BTvalue.toInt();
      break;

    case 2244:
      autoenabled = BTvalue.toInt();
      if (autoenabled == 0) {
        autoRefRunX = false;
      }
      else {
        autoRefRunX = true;
        Serial.print("autoRefRunX:");
        Serial.println(autoRefRunX);
      }
      break;
    //-----------LIMIT Y-axis-----------
    case 2205:
      limitenabled = BTvalue.toInt();
      if (limitenabled == 0) {
        limitEnabledY = false;
      }
      else {
        limitEnabledY = true;
      }
      break;
    case 2215:
      limitStepsY = BTvalue.toInt();
      break;

    case 2225:
      limitSwitchPinY = BTvalue.toInt();
      pinMode(limitSwitchPinY, INPUT_PULLDOWN);
      break;

    case 2235:
      limitBackOffY = BTvalue.toInt();
      break;

    case 2245:
      autoenabled = BTvalue.toInt();
      if (autoenabled == 0) {
        autoRefRunY = false;
      }
      else {
        autoRefRunY = true;
        Serial.print("autoRefRunY:");
        Serial.println(autoRefRunY);
      }
      break;
    //-----------LIMIT Z-axis-----------
    case 2206:
      limitenabled = BTvalue.toInt();
      if (limitenabled == 0) {
        limitEnabledZ = false;
      }
      else {
        limitEnabledZ = true;
      }
      break;
    case 2216:
      limitStepsZ = BTvalue.toInt();
      break;

    case 2226:
      limitSwitchPinZ = BTvalue.toInt();
      pinMode(limitSwitchPinZ, INPUT_PULLDOWN);
      break;

    case 2236:
      limitBackOffZ = BTvalue.toInt();
      break;

    case 2246:
      autoenabled = BTvalue.toInt();
      if (autoenabled == 0) {
        autoRefRunZ = false;
      }
      else {
        autoRefRunZ = true;
      }
      break;

    case 2250:
      Serial.println("autoRefstart");
      limitStepsUoffset = 0;
      limitStepsVoffset = 0;
      limitStepsWoffset = 0;
      limitStepsXoffset = 0;
      limitStepsYoffset = 0;
      limitStepsZoffset = 0;

      autorefrun();


      break;


  }
}

void returnvalues() {

  int intervalsend = TLinterval / 1000;
  myString = String(intervalsend);
  StringSend = "#interval_" + myString + "$";
  Serial5.print(StringSend);

  delay(50);
  myString = String(totalPicNo);
  StringSend = "#totalPicNo_" + myString + "$";
  Serial5.print(StringSend);

  delay(50);
  myString = String(currentPicNo);
  StringSend = "#currentPicNo_" + myString + "$";
  Serial5.print(StringSend);

}


uint8_t tmc_write(int axis, uint8_t cmd, uint32_t data)
{
  uint8_t s;

  //  Serial.println("SPI------------------------------");
  // Serial.println(data);

  SPI.beginTransaction(settingsA);
  switch (axis) {
    case 1:
      digitalWrite(Xcs, LOW);
      break;
    case 2:
      digitalWrite(Ycs, LOW);
      break;
    case 3:
      digitalWrite(Zcs, LOW);
      break;
    case 4:
      digitalWrite(Ucs, LOW);
      break;
    case 5:
      digitalWrite(Vcs, LOW);
      break;
    case 6:
      digitalWrite(Wcs, LOW);
      break;
  }


  s = SPI.transfer(cmd);
  SPI.transfer((data >> 24UL) & 0xFF) & 0xFF;
  SPI.transfer((data >> 16UL) & 0xFF) & 0xFF;
  SPI.transfer((data >> 8UL) & 0xFF) & 0xFF;
  SPI.transfer((data >> 0UL) & 0xFF) & 0xFF;

  switch (axis) {
    case 1:
      digitalWrite(Xcs, HIGH);
      break;
    case 2:
      digitalWrite(Ycs, HIGH);
      break;
    case 3:
      digitalWrite(Zcs, HIGH);
      break;
    case 4:
      digitalWrite(Ucs, HIGH);
      break;
    case 5:
      digitalWrite(Vcs, HIGH);
      break;
    case 6:
      digitalWrite(Wcs, HIGH);
      break;
  }
  SPI.endTransaction();
  return s;
}
